*
* example of an 2 level PWM/PFM stacked DC/DC converter.   
*
*
.include "../../technology/100nm_nominal_H"
.include "../../subckt/basic33.sp"
.include "../../subckt/buck33.sp"

.param lamda=0.05u
.param param_vdd=3.3
.param param_ref1=1.3
.param param_ref2=1.0 

xpwm nvdd1 0 ref_total npwm_out 0 buck_pwm_33 
xcomp ref1 npwm_out enable nvdd2 ngnd2 volt_comp_33 vc_freq=100e6
xpfm enable nvdd2 ngnd2 npwm_out ngnd2 nvdd2 buck_pfm_33 lf=100n cf=200n csnub=0.1n freq=15e6 pulse_time=18n

vvdd1 nvdd1 0 param_vdd
vvdd2 nvdd2 ngnd2 param_vdd
vref_total ref_total 0 'param_ref1 + param_ref2'
vref1 ref1 ngnd2 param_ref1

.ic v(npwm_out) 2.3
*.ic v(ngnd2) 1.0

r1 npwm_out ngnd2 1
r2 ngnd2 0 1

.options post measout probe fast GDCMIN=1e-12 LVLTIM=0
.probe v(npwm_out) v(ref_total) v(ngnd2) v(enable) i(i_cm138a_k4_cap_sp) i(i_b1_k4_cap_sp)
.meas total_power1 avg p(vvdd1) from=15u to=30u
.meas total_power2 avg p(vvdd2) from=15u to=30u
.meas max_output1 max v(npwm_out) from=15u to=30u
.meas min_output1 min v(npwm_out) from=15u to=30u
.meas max_output2 max v(ngnd2) from=15u to=30u
.meas min_output2 min v(ngnd2) from=15u to=30u

.tran 0.05n 30u
.op

.end
