*A two stage buffer (stage ratio 2)
*scalable lamda design rule

* Fei LI
* 07/17/02


* (1) BUFF2x
* (2) BUFF2x_H
* (3) BUFF2x_EH
* (4) BUFF4x
* (5) BUFF5x
* (6) BUFF1x

* parameters
* =================
* lmda: design rule parameters (set in the file parameters.sp)
* v_supply: supply votage (set in the file parameters.sp)

* ports of the subckt and their functions
* =======================================
* vsp: source for PMOS transistors in the x-coupled inverters
*      usually connected to Vdd or virtual Vdd
* vbp: bulk for the PMOS transistors in the SRAM cell
* vsn: source for NMOS transistors in the x-coupled inverters
*      usually connected to Gnd or virtual Gnd
* vbn: bulk for the NMOS transistors in the SRAM cell
* in : input
* out: output


* (1) BUFF2x

.subckt BUFF2x vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

x1 vsp vbp vsn vbn in       internal INV
x2 vsp vbp vsn vbn internal out      INV2x

.ends BUFF2x


* (2) BUFF2x_H

.subckt BUFF2x_H vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

x1 vsp vbp vsn vbn in       internal INV_H
x2 vsp vbp vsn vbn internal out      INV2x_H

.ends BUFF2x_H




* (3) BUFF2x_EH

.subckt BUFF2x_EH vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

x1 vsp vbp vsn vbn in       internal INV_EH
x2 vsp vbp vsn vbn internal out      INV2x_EH

.ends BUFF2x_EH

* (4) BUFF4x

.subckt BUFF4x vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

x1 vsp vbp vsn vbn in       internal INV
x2 vsp vbp vsn vbn internal out      INV4x

.ends BUFF4x


* (5) BUFF5x

.subckt BUFF5x vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

x1 vsp vbp vsn vbn in       internal INV
x2 vsp vbp vsn vbn internal out      INV5x

.ends BUFF5x


* (6) BUFF1x

.subckt BUFF1x vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

x1 vsp vbp vsn vbn in       internal INV
x2 vsp vbp vsn vbn internal out      INV

.ends BUFF1x


* (7) BUFF7x_track

.subckt BUFF7x_track vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

x1 vsp vbp vsn vbn in       internal INV2x
x2 vsp vbp vsn vbn internal out      INV7x

.ends BUFF7x_track


* (8) BUFF10x_track

.subckt BUFF10x_track vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

x1 vsp vbp vsn vbn in       internal INV2x
x2 vsp vbp vsn vbn internal out      INV10x

.ends BUFF10x_track


* (9) BUFF12x_track

.subckt BUFF12x_track vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

x1 vsp vbp vsn vbn in       internal INV3x
x2 vsp vbp vsn vbn internal out      INV12x

.ends BUFF12x_track


* (10) BUFF15x_track

.subckt BUFF15x_track vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

x1 vsp vbp vsn vbn in       internal INV
x2 vsp vbp vsn vbn internal internal1 INV3x
x3 vsp vbp vsn vbn internal1 internal2 INV9x
x4 vsp vbp vsn vbn internal2 out INV15x

.ends BUFF15x_track

* (11) BUFF17x_track

.subckt BUFF17x_track vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

x1 vsp vbp vsn vbn in       internal INV
x2 vsp vbp vsn vbn internal internal1 INV3x
x3 vsp vbp vsn vbn internal1 internal2 INV9x
x4 vsp vbp vsn vbn internal2 out INV17x

.ends BUFF17x_track

* (12) BUFF20x_track

.subckt BUFF20x_track vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

x1 vsp vbp vsn vbn in       internal INV
x2 vsp vbp vsn vbn internal internal1 INV3x
x3 vsp vbp vsn vbn internal1 internal2 INV9x
x4 vsp vbp vsn vbn internal2 out INV20x

.ends BUFF20x_track


* (13) BUFF22x_track

.subckt BUFF22x_track vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

x1 vsp vbp vsn vbn in       internal INV
x2 vsp vbp vsn vbn internal internal1 INV3x
x3 vsp vbp vsn vbn internal1 internal2 INV9x
x4 vsp vbp vsn vbn internal2 out INV22x

.ends BUFF22x_track

* (14) BUFF25x_track

.subckt BUFF25x_track vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

x1 vsp vbp vsn vbn in       internal INV
x2 vsp vbp vsn vbn internal internal1 INV3x
x3 vsp vbp vsn vbn internal1 internal2 INV9x
x4 vsp vbp vsn vbn internal2 out INV25x

.ends BUFF25x_track


* (15) BUFF27x_track

.subckt BUFF27x_track vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

x1 vsp vbp vsn vbn in       internal INV
x2 vsp vbp vsn vbn internal internal1 INV3x
x3 vsp vbp vsn vbn internal1 internal2 INV9x
x4 vsp vbp vsn vbn internal2 out INV27x

.ends BUFF27x_track


* (16) BUFF30x_track

.subckt BUFF30x_track vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

x1 vsp vbp vsn vbn in       internal INV
x2 vsp vbp vsn vbn internal internal1 INV3x
x3 vsp vbp vsn vbn internal1 internal2 INV9x
x4 vsp vbp vsn vbn internal2 out INV30x

.ends BUFF30x_track


* (17) BUFF35x_track

.subckt BUFF35x_track vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

x1 vsp vbp vsn vbn in       internal INV
x2 vsp vbp vsn vbn internal internal1 INV3x
x3 vsp vbp vsn vbn internal1 internal2 INV9x
x4 vsp vbp vsn vbn internal2 out INV35x

.ends BUFF35x_track

* (18) BUFF40x_track

.subckt BUFF40x_track vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

x1 vsp vbp vsn vbn in       internal INV
x2 vsp vbp vsn vbn internal internal1 INV4x
x3 vsp vbp vsn vbn internal1 internal2 INV12x
x4 vsp vbp vsn vbn internal2 out INV40x

.ends BUFF40x_track

* (19) BUFF_min5x

.subckt BUFF_min5x vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

x1 vsp vbp vsn vbn in       internal INV_min
x2 vsp vbp vsn vbn internal out      INV_min5x

.ends BUFF_min5x


*()  BUFF4x_VDDL10

.subckt BUFF4x_VDDL10 vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

x1 vsp vbp vsn vbn in       internal INV_VDDL10
x2 vsp vbp vsn vbn internal out      INV4x_VDDL10

.ends BUFF4x_VDDL10

*()  BUFF4x_VDDL09

.subckt BUFF4x_VDDL09 vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

x1 vsp vbp vsn vbn in       internal INV_VDDL09
x2 vsp vbp vsn vbn internal out      INV4x_VDDL09

.ends BUFF4x_VDDL09

* ()  BUFF4x_VDDL08

.subckt BUFF4x_VDDL08 vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

x1 vsp vbp vsn vbn in       internal INV_VDDL08
x2 vsp vbp vsn vbn internal out      INV4x_VDDL08

.ends BUFF4x_VDDL08

* () BUFF5x_VDDL10

.subckt BUFF5x_VDDL10 vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

x1 vsp vbp vsn vbn in       internal INV_VDDL10
x2 vsp vbp vsn vbn internal out      INV5x_VDDL10

.ends BUFF5x_VDDL10


* () BUFF5x_VDDL09

.subckt BUFF5x_VDDL09 vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

x1 vsp vbp vsn vbn in       internal INV_VDDL09
x2 vsp vbp vsn vbn internal out      INV5x_VDDL09

.ends BUFF5x_VDDL09

* () BUFF5x_VDDL08

.subckt BUFF5x_VDDL08 vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

x1 vsp vbp vsn vbn in       internal INV_VDDL08
x2 vsp vbp vsn vbn internal out      INV5x_VDDL08

.ends BUFF5x_VDDL08

* () BUFF7x_track_VDDL10

.subckt BUFF7x_track_VDDL10 vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

x1 vsp vbp vsn vbn in       internal INV2x_VDDL10
x2 vsp vbp vsn vbn internal out      INV7x_VDDL10

.ends BUFF7x_track_VDDL10

* () BUFF7x_track_VDDL09

.subckt BUFF7x_track_VDDL09 vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

x1 vsp vbp vsn vbn in       internal INV2x_VDDL09
x2 vsp vbp vsn vbn internal out      INV7x_VDDL09

.ends BUFF7x_track_VDDL09

* () BUFF7x_track_VDDL08

.subckt BUFF7x_track_VDDL08 vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

x1 vsp vbp vsn vbn in       internal INV2x_VDDL08
x2 vsp vbp vsn vbn internal out      INV7x_VDDL08

.ends BUFF7x_track_VDDL08

* () BUFF10x_track_VDDL10

.subckt BUFF10x_track_VDDL10 vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

x1 vsp vbp vsn vbn in       internal INV2x_VDDL10
x2 vsp vbp vsn vbn internal out      INV10x_VDDL10

.ends BUFF10x_track_VDDL10

* () BUFF10x_track_VDDL09

.subckt BUFF10x_track_VDDL09 vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

x1 vsp vbp vsn vbn in       internal INV2x_VDDL09
x2 vsp vbp vsn vbn internal out      INV10x_VDDL09

.ends BUFF10x_track_VDDL09

* () BUFF10x_track_VDDL08

.subckt BUFF10x_track_VDDL08 vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

x1 vsp vbp vsn vbn in       internal INV2x_VDDL08
x2 vsp vbp vsn vbn internal out      INV10x_VDDL08

.ends BUFF10x_track_VDDL08

* () BUFF12x_track_VDDL10

.subckt BUFF12x_track_VDDL10 vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

x1 vsp vbp vsn vbn in       internal INV3x_VDDL10
x2 vsp vbp vsn vbn internal out      INV12x_VDDL10

.ends BUFF12x_track_VDDL10

* () BUFF12x_track_VDDL09

.subckt BUFF12x_track_VDDL09 vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

x1 vsp vbp vsn vbn in       internal INV3x_VDDL09
x2 vsp vbp vsn vbn internal out      INV12x_VDDL09

.ends BUFF12x_track_VDDL09

* () BUFF12x_track_VDDL08

.subckt BUFF12x_track_VDDL08 vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

x1 vsp vbp vsn vbn in       internal INV3x_VDDL08
x2 vsp vbp vsn vbn internal out      INV12x_VDDL08

.ends BUFF12x_track_VDDL08

* () BUFF15x_track_VDDL10

.subckt BUFF15x_track_VDDL10 vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

x1 vsp vbp vsn vbn in       internal INV_VDDL10
x2 vsp vbp vsn vbn internal internal1 INV3x_VDDL10
x3 vsp vbp vsn vbn internal1 internal2 INV9x_VDDL10
x4 vsp vbp vsn vbn internal2 out INV15x_VDDL10

.ends BUFF15x_track_VDDL10

* () BUFF15x_track_VDDL09

.subckt BUFF15x_track_VDDL09 vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

x1 vsp vbp vsn vbn in       internal INV_VDDL09
x2 vsp vbp vsn vbn internal internal1 INV3x_VDDL09
x3 vsp vbp vsn vbn internal1 internal2 INV9x_VDDL09
x4 vsp vbp vsn vbn internal2 out INV15x_VDDL09

.ends BUFF15x_track_VDDL09

* () BUFF15x_track_VDDL08

.subckt BUFF15x_track_VDDL08 vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

x1 vsp vbp vsn vbn in       internal INV_VDDL08
x2 vsp vbp vsn vbn internal internal1 INV3x_VDDL08
x3 vsp vbp vsn vbn internal1 internal2 INV9x_VDDL08
x4 vsp vbp vsn vbn internal2 out INV15x_VDDL08

.ends BUFF15x_track_VDDL08

* () BUFF17x_track_VDDL10

.subckt BUFF17x_track_VDDL10 vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

x1 vsp vbp vsn vbn in       internal INV_VDDL10
x2 vsp vbp vsn vbn internal internal1 INV3x_VDDL10
x3 vsp vbp vsn vbn internal1 internal2 INV9x_VDDL10
x4 vsp vbp vsn vbn internal2 out INV17x_VDDL10

.ends BUFF17x_track_VDDL10

* () BUFF17x_track_VDDL09

.subckt BUFF17x_track_VDDL09 vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

x1 vsp vbp vsn vbn in       internal INV_VDDL09
x2 vsp vbp vsn vbn internal internal1 INV3x_VDDL09
x3 vsp vbp vsn vbn internal1 internal2 INV9x_VDDL09
x4 vsp vbp vsn vbn internal2 out INV17x_VDDL09

.ends BUFF17x_track_VDDL09

* () BUFF17x_track_VDDL08

.subckt BUFF17x_track_VDDL08 vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

x1 vsp vbp vsn vbn in       internal INV_VDDL08
x2 vsp vbp vsn vbn internal internal1 INV3x_VDDL08
x3 vsp vbp vsn vbn internal1 internal2 INV9x_VDDL08
x4 vsp vbp vsn vbn internal2 out INV17x_VDDL08

.ends BUFF17x_track_VDDL08

* () BUFF20x_track_VDDL10

.subckt BUFF20x_track_VDDL10 vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

x1 vsp vbp vsn vbn in       internal INV_VDDL10
x2 vsp vbp vsn vbn internal internal1 INV3x_VDDL10
x3 vsp vbp vsn vbn internal1 internal2 INV9x_VDDL10
x4 vsp vbp vsn vbn internal2 out INV20x_VDDL10

.ends BUFF20x_track_VDDL10

* () BUFF20x_track_VDDL09

.subckt BUFF20x_track_VDDL09 vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

x1 vsp vbp vsn vbn in       internal INV_VDDL09
x2 vsp vbp vsn vbn internal internal1 INV3x_VDDL09
x3 vsp vbp vsn vbn internal1 internal2 INV9x_VDDL09
x4 vsp vbp vsn vbn internal2 out INV20x_VDDL09

.ends BUFF20x_track_VDDL09

* () BUFF20x_track_VDDL08

.subckt BUFF20x_track_VDDL08 vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

x1 vsp vbp vsn vbn in       internal INV_VDDL08
x2 vsp vbp vsn vbn internal internal1 INV3x_VDDL08
x3 vsp vbp vsn vbn internal1 internal2 INV9x_VDDL08
x4 vsp vbp vsn vbn internal2 out INV20x_VDDL08

.ends BUFF20x_track_VDDL08

* () BUFF22x_track_VDDL10

.subckt BUFF22x_track_VDDL10 vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

x1 vsp vbp vsn vbn in       internal INV_VDDL10
x2 vsp vbp vsn vbn internal internal1 INV3x_VDDL10
x3 vsp vbp vsn vbn internal1 internal2 INV9x_VDDL10
x4 vsp vbp vsn vbn internal2 out INV22x_VDDL10

.ends BUFF22x_track_VDDL10

* () BUFF22x_track_VDDL09

.subckt BUFF22x_track_VDDL09 vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

x1 vsp vbp vsn vbn in       internal INV_VDDL09
x2 vsp vbp vsn vbn internal internal1 INV3x_VDDL09
x3 vsp vbp vsn vbn internal1 internal2 INV9x_VDDL09
x4 vsp vbp vsn vbn internal2 out INV22x_VDDL09

.ends BUFF22x_track_VDDL09

* () BUFF22x_track_VDDL08

.subckt BUFF22x_track_VDDL08 vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

x1 vsp vbp vsn vbn in       internal INV_VDDL08
x2 vsp vbp vsn vbn internal internal1 INV3x_VDDL08
x3 vsp vbp vsn vbn internal1 internal2 INV9x_VDDL08
x4 vsp vbp vsn vbn internal2 out INV22x_VDDL08

.ends BUFF22x_track_VDDL08

* () BUFF25x_track_VDDL10

.subckt BUFF25x_track_VDDL10 vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

x1 vsp vbp vsn vbn in       internal INV_VDDL10
x2 vsp vbp vsn vbn internal internal1 INV3x_VDDL10
x3 vsp vbp vsn vbn internal1 internal2 INV9x_VDDL10
x4 vsp vbp vsn vbn internal2 out INV25x_VDDL10

.ends BUFF25x_track_VDDL10

* () BUFF25x_track_VDDL09

.subckt BUFF25x_track_VDDL09 vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

x1 vsp vbp vsn vbn in       internal INV_VDDL09
x2 vsp vbp vsn vbn internal internal1 INV3x_VDDL09
x3 vsp vbp vsn vbn internal1 internal2 INV9x_VDDL09
x4 vsp vbp vsn vbn internal2 out INV25x_VDDL09

.ends BUFF25x_track_VDDL09

* () BUFF25x_track_VDDL08

.subckt BUFF25x_track_VDDL08 vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

x1 vsp vbp vsn vbn in       internal INV_VDDL08
x2 vsp vbp vsn vbn internal internal1 INV3x_VDDL08
x3 vsp vbp vsn vbn internal1 internal2 INV9x_VDDL08
x4 vsp vbp vsn vbn internal2 out INV25x_VDDL08

.ends BUFF25x_track_VDDL08

* () BUFF27x_track_VDDL10

.subckt BUFF27x_track_VDDL10 vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

x1 vsp vbp vsn vbn in       internal INV_VDDL10
x2 vsp vbp vsn vbn internal internal1 INV3x_VDDL10
x3 vsp vbp vsn vbn internal1 internal2 INV9x_VDDL10
x4 vsp vbp vsn vbn internal2 out INV27x_VDDL10

.ends BUFF27x_track_VDDL10

* () BUFF27x_track_VDDL09

.subckt BUFF27x_track_VDDL09 vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

x1 vsp vbp vsn vbn in       internal INV_VDDL09
x2 vsp vbp vsn vbn internal internal1 INV3x_VDDL09
x3 vsp vbp vsn vbn internal1 internal2 INV9x_VDDL09
x4 vsp vbp vsn vbn internal2 out INV27x_VDDL09

.ends BUFF27x_track_VDDL09

* () BUFF27x_track_VDDL08

.subckt BUFF27x_track_VDDL08 vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

x1 vsp vbp vsn vbn in       internal INV_VDDL08
x2 vsp vbp vsn vbn internal internal1 INV3x_VDDL08
x3 vsp vbp vsn vbn internal1 internal2 INV9x_VDDL08
x4 vsp vbp vsn vbn internal2 out INV27x_VDDL08

.ends BUFF27x_track_VDDL08

* () BUFF30x_track_VDDL10

.subckt BUFF30x_track_VDDL10 vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

x1 vsp vbp vsn vbn in       internal INV_VDDL10
x2 vsp vbp vsn vbn internal internal1 INV3x_VDDL10
x3 vsp vbp vsn vbn internal1 internal2 INV9x_VDDL10
x4 vsp vbp vsn vbn internal2 out INV30x_VDDL10

.ends BUFF30x_track_VDDL10

* () BUFF30x_track_VDDL09

.subckt BUFF30x_track_VDDL09 vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

x1 vsp vbp vsn vbn in       internal INV_VDDL09
x2 vsp vbp vsn vbn internal internal1 INV3x_VDDL09
x3 vsp vbp vsn vbn internal1 internal2 INV9x_VDDL09
x4 vsp vbp vsn vbn internal2 out INV30x_VDDL09

.ends BUFF30x_track_VDDL09

* () BUFF30x_track_VDDL08

.subckt BUFF30x_track_VDDL08 vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

x1 vsp vbp vsn vbn in       internal INV_VDDL08
x2 vsp vbp vsn vbn internal internal1 INV3x_VDDL08
x3 vsp vbp vsn vbn internal1 internal2 INV9x_VDDL08
x4 vsp vbp vsn vbn internal2 out INV30x_VDDL08

.ends BUFF30x_track_VDDL08

* () BUFF35x_track_VDDL10

.subckt BUFF35x_track_VDDL10 vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

x1 vsp vbp vsn vbn in       internal INV_VDDL10
x2 vsp vbp vsn vbn internal internal1 INV3x_VDDL10
x3 vsp vbp vsn vbn internal1 internal2 INV9x_VDDL10
x4 vsp vbp vsn vbn internal2 out INV35x_VDDL10

.ends BUFF35x_track_VDDL10

* () BUFF35x_track_VDDL09

.subckt BUFF35x_track_VDDL09 vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

x1 vsp vbp vsn vbn in       internal INV_VDDL09
x2 vsp vbp vsn vbn internal internal1 INV3x_VDDL09
x3 vsp vbp vsn vbn internal1 internal2 INV9x_VDDL09
x4 vsp vbp vsn vbn internal2 out INV35x_VDDL09

.ends BUFF35x_track_VDDL09

* () BUFF35x_track_VDDL08

.subckt BUFF35x_track_VDDL08 vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

x1 vsp vbp vsn vbn in       internal INV_VDDL08
x2 vsp vbp vsn vbn internal internal1 INV3x_VDDL08
x3 vsp vbp vsn vbn internal1 internal2 INV9x_VDDL08
x4 vsp vbp vsn vbn internal2 out INV35x_VDDL08

.ends BUFF35x_track_VDDL08

* () BUFF40x_track_VDDL10

.subckt BUFF40x_track_VDDL10 vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

x1 vsp vbp vsn vbn in       internal INV_VDDL10
x2 vsp vbp vsn vbn internal internal1 INV4x_VDDL10
x3 vsp vbp vsn vbn internal1 internal2 INV12x_VDDL10
x4 vsp vbp vsn vbn internal2 out INV40x_VDDL10

.ends BUFF40x_track_VDDL10

* () BUFF40x_track_VDDL09

.subckt BUFF40x_track_VDDL09 vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

x1 vsp vbp vsn vbn in       internal INV_VDDL09
x2 vsp vbp vsn vbn internal internal1 INV4x_VDDL09
x3 vsp vbp vsn vbn internal1 internal2 INV12x_VDDL09
x4 vsp vbp vsn vbn internal2 out INV40x_VDDL09

.ends BUFF40x_track_VDDL09

* () BUFF40x_track_VDDL08

.subckt BUFF40x_track_VDDL08 vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

x1 vsp vbp vsn vbn in       internal INV_VDDL08
x2 vsp vbp vsn vbn internal internal1 INV4x_VDDL08
x3 vsp vbp vsn vbn internal1 internal2 INV12x_VDDL08
x4 vsp vbp vsn vbn internal2 out INV40x_VDDL08

.ends BUFF40x_track_VDDL08

* () BUFF2x_VDDL10

.subckt BUFF2x_VDDL10 vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

x1 vsp vbp vsn vbn in       internal INV_VDDL10
x2 vsp vbp vsn vbn internal out      INV2x_VDDL10

.ends BUFF2x_VDDL10

* () BUFF2x_VDDL09

.subckt BUFF2x_VDDL09 vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

x1 vsp vbp vsn vbn in       internal INV_VDDL09
x2 vsp vbp vsn vbn internal out      INV2x_VDDL09

.ends BUFF2x_VDDL09


* () BUFF2x_VDDL08

.subckt BUFF2x_VDDL08 vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

x1 vsp vbp vsn vbn in       internal INV_VDDL08
x2 vsp vbp vsn vbn internal out      INV2x_VDDL08

.ends BUFF2x_VDDL08

