*decoder(minimum width)
*scalable lamda design rule

* Fei LI
*09/16/04

* parameters
* =================
* lmda: design rule parameters (set in the file parameters.sp)
* v_supply: supply votage (set in the file parameters.sp)
                                                                                
* ports of the subckt and their functions
* =======================================
* vsp: source for PMOS transistors in the x-coupled inverters
*      usually connected to Vdd or virtual Vdd
* vbp: bulk for the PMOS transistors in the SRAM cell
* vsn: source for NMOS transistors in the x-coupled inverters
*      usually connected to Gnd or virtual Gnd
* vbn: bulk for the NMOS transistors in the SRAM cell
* out:    output
                                                                                
.subckt DECODER5_32_H vsp vbp vsn vbn i0 i1 i2 i3 i4
+ d0 d1 d2 d3 d4 d5 d6 d7 d8 d9 d10 d11 d12 d13 d14 d15 d16 d17 d18
+ d19 d20 d21 d22 d23 d24 d25 d26 d27 d28 d29 d30 d31
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u

x0_inv vsp vbp vsn vbn i0 i0_bar INV_H
x1_inv vsp vbp vsn vbn i1 i1_bar INV_H
x2_inv vsp vbp vsn vbn i2 i2_bar INV_H
x3_inv vsp vbp vsn vbn i3 i3_bar INV_H
x4_inv vsp vbp vsn vbn i4 i4_bar INV_H

* combination of i0 and i1
xnand_a00 vsp vbp vsn vbn i0_bar i1_bar int_a00 NAND2_H
xnand_a10 vsp vbp vsn vbn i0     i1_bar int_a10 NAND2_H
xnand_a01 vsp vbp vsn vbn i0_bar i1     int_a01 NAND2_H
xnand_a11 vsp vbp vsn vbn i0     i1     int_a11 NAND2_H

* combinationa of i2 and i3
xnand_b00 vsp vbp vsn vbn i2_bar i3_bar int_b00 NAND2_H
xnand_b10 vsp vbp vsn vbn i2     i3_bar int_b10 NAND2_H
xnand_b01 vsp vbp vsn vbn i2_bar i3     int_b01 NAND2_H
xnand_b11 vsp vbp vsn vbn i2     i3     int_b11 NAND2_H

* outputs
* 00000
xout0 vsp vbp vsn vbn int_a00 int_b00 i4 d0 NOR3_H
* 10000
xout1 vsp vbp vsn vbn int_a10 int_b00 i4 d1 NOR3_H
* 01000
xout2 vsp vbp vsn vbn int_a01 int_b00 i4 d2 NOR3_H
* 11000
xout3 vsp vbp vsn vbn int_a11 int_b00 i4 d3 NOR3_H
* 00100
xout4 vsp vbp vsn vbn int_a00 int_b10 i4 d4 NOR3_H
* 10100
xout5 vsp vbp vsn vbn int_a10 int_b10 i4 d5 NOR3_H
* 01100
xout6 vsp vbp vsn vbn int_a01 int_b10 i4 d6 NOR3_H
* 11100
xout7 vsp vbp vsn vbn int_a11 int_b10 i4 d7 NOR3_H
* 00010
xout8 vsp vbp vsn vbn int_a00 int_b01 i4 d8 NOR3_H
* 10010
xout9 vsp vbp vsn vbn int_a10 int_b01 i4 d9 NOR3_H
* 01010
xout10 vsp vbp vsn vbn int_a01 int_b01 i4 d10 NOR3_H
* 11010
xout11 vsp vbp vsn vbn int_a11 int_b01 i4 d11 NOR3_H
* 00110
xout12 vsp vbp vsn vbn int_a00 int_b11 i4 d12 NOR3_H
* 10110
xout13 vsp vbp vsn vbn int_a10 int_b11 i4 d13 NOR3_H
* 01110
xout14 vsp vbp vsn vbn int_a01 int_b11 i4 d14 NOR3_H
* 11110
xout15 vsp vbp vsn vbn int_a11 int_b11 i4 d15 NOR3_H
* 00001
xout16 vsp vbp vsn vbn int_a00 int_b00 i4_bar d16 NOR3_H
* 10001
xout17 vsp vbp vsn vbn int_a10 int_b00 i4_bar d17 NOR3_H
* 01001
xout18 vsp vbp vsn vbn int_a01 int_b00 i4_bar d18 NOR3_H
* 11001
xout19 vsp vbp vsn vbn int_a11 int_b00 i4_bar d19 NOR3_H
* 00101
xout20 vsp vbp vsn vbn int_a00 int_b10 i4_bar d20 NOR3_H
* 10101
xout21 vsp vbp vsn vbn int_a10 int_b10 i4_bar d21 NOR3_H
* 01101
xout22 vsp vbp vsn vbn int_a01 int_b10 i4_bar d22 NOR3_H
* 11101
xout23 vsp vbp vsn vbn int_a11 int_b10 i4_bar d23 NOR3_H
* 00011
xout24 vsp vbp vsn vbn int_a00 int_b01 i4_bar d24 NOR3_H
* 10011
xout25 vsp vbp vsn vbn int_a10 int_b01 i4_bar d25 NOR3_H
* 01011
xout26 vsp vbp vsn vbn int_a01 int_b01 i4_bar d26 NOR3_H
* 11011
xout27 vsp vbp vsn vbn int_a11 int_b01 i4_bar d27 NOR3_H
* 00111
xout28 vsp vbp vsn vbn int_a00 int_b11 i4_bar d28 NOR3_H
* 10111
xout29 vsp vbp vsn vbn int_a10 int_b11 i4_bar d29 NOR3_H
* 01111
xout30 vsp vbp vsn vbn int_a01 int_b11 i4_bar d30 NOR3_H
* 11111
xout31 vsp vbp vsn vbn int_a11 int_b11 i4_bar d31 NOR3_H

.ends DECODER5_32_H
