*A mimum width inverter
*scalable lamda design rule

* Fei Li
* 07/17/02


* (1) INV: normal inverter
* (2) INV_H: high-threashould inverter
* (3) INV_EH: Even higher threshould inverter

* parameters
* =================
* lmda: design rule parameters (set in the file parameters.sp)
* v_supply: supply votage (set in the file parameters.sp)

* ports of the subckt and their functions
* =======================================
* vsp: source for PMOS transistors in the x-coupled inverters
*      usually connected to Vdd or virtual Vdd
* vbp: bulk for the PMOS transistors in the SRAM cell
* vsn: source for NMOS transistors in the x-coupled inverters
*      usually connected to Gnd or virtual Gnd
* vbn: bulk for the NMOS transistors in the SRAM cell
* in : input
* out: output


*(1)

.subckt INV vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out in vsn vbn NMOS l='2*lmda' w='3.5*lmda' ad='24.5*lmda*lmda'
+ as='24.5*lmda*lmda' pd='21*lmda' ps='21*lmda'
m2 out in vsp vbp PMOS l='2*lmda' w='8.75*lmda' ad='153.125*lmda*lmda'
+ as='153.125*lmda*lmda' pd='52.5*lmda' ps='52.5*lmda'
.ends INV

.subckt INV_skew vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out in vsn vbn NMOS l='2*lmda' w='5.5*lmda' ad='24.5*lmda*lmda'
+ as='24.5*lmda*lmda' pd='21*lmda' ps='21*lmda'
m2 out in vsp vbp PMOS l='2*lmda' w='8.75*lmda' ad='153.125*lmda*lmda'
+ as='153.125*lmda*lmda' pd='52.5*lmda' ps='52.5*lmda'
.ends INV_skew



*(2)

.subckt INV_H vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out in vsn vbn NMOS_H l='2*lmda' w='3.5*lmda' ad='24.5*lmda*lmda'
+ as='24.5*lmda*lmda' pd='21*lmda' ps='21*lmda'
m2 out in vsp vbp PMOS_H l='2*lmda' w='8.75*lmda' ad='153.125*lmda*lmda'
+ as='153.125*lmda*lmda' pd='52.5*lmda' ps='52.5*lmda'
.ends INV_H


*(3)

.subckt INV_EH vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out in vsn vbn NMOS_EH l='2*lmda' w='3.5*lmda' ad='24.5*lmda*lmda'
+ as='24.5*lmda*lmda' pd='21*lmda' ps='21*lmda'
m2 out in vsp vbp PMOS_EH l='2*lmda' w='8.75*lmda' ad='153.125*lmda*lmda'
+ as='153.125*lmda*lmda' pd='52.5*lmda' ps='52.5*lmda'
.ends INV_EH

*(4) for low vdd = 1.0v, the Vt is scaled

.subckt INV_VDDL10 vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out in vsn vbn NMOS_VDDL10 l='2*lmda' w='3.5*lmda' ad='24.5*lmda*lmda'
+ as='24.5*lmda*lmda' pd='21*lmda' ps='21*lmda'
m2 out in vsp vbp PMOS_VDDL10 l='2*lmda' w='8.75*lmda' ad='153.125*lmda*lmda'
+ as='153.125*lmda*lmda' pd='52.5*lmda' ps='52.5*lmda'
.ends INV_VDDL10

.subckt INV_VDDL10_skew vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out in vsn vbn NMOS_VDDL10 l='2*lmda' w='5.5*lmda' ad='24.5*lmda*lmda'
+ as='24.5*lmda*lmda' pd='21*lmda' ps='21*lmda'
m2 out in vsp vbp PMOS_VDDL10 l='2*lmda' w='8.75*lmda' ad='153.125*lmda*lmda'
+ as='153.125*lmda*lmda' pd='52.5*lmda' ps='52.5*lmda'
.ends INV_VDDL10_skew

*(5) for low vdd = 0.9v, the Vt is scaled

.subckt INV_VDDL09 vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out in vsn vbn NMOS_VDDL09 l='2*lmda' w='3.5*lmda' ad='24.5*lmda*lmda'
+ as='24.5*lmda*lmda' pd='21*lmda' ps='21*lmda'
m2 out in vsp vbp PMOS_VDDL09 l='2*lmda' w='8.75*lmda' ad='153.125*lmda*lmda'
+ as='153.125*lmda*lmda' pd='52.5*lmda' ps='52.5*lmda'
.ends INV_VDDL09


.subckt INV_VDDL09_skew vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out in vsn vbn NMOS_VDDL09 l='2*lmda' w='5.5*lmda' ad='24.5*lmda*lmda'
+ as='24.5*lmda*lmda' pd='21*lmda' ps='21*lmda'
m2 out in vsp vbp PMOS_VDDL09 l='2*lmda' w='8.75*lmda' ad='153.125*lmda*lmda'
+ as='153.125*lmda*lmda' pd='52.5*lmda' ps='52.5*lmda'
.ends INV_VDDL09_skew


*(6) for low vdd = 0.8v, the Vt is scaled

.subckt INV_VDDL08 vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out in vsn vbn NMOS_VDDL08 l='2*lmda' w='3.5*lmda' ad='24.5*lmda*lmda'
+ as='24.5*lmda*lmda' pd='21*lmda' ps='21*lmda'
m2 out in vsp vbp PMOS_VDDL08 l='2*lmda' w='8.75*lmda' ad='153.125*lmda*lmda'
+ as='153.125*lmda*lmda' pd='52.5*lmda' ps='52.5*lmda'
.ends INV_VDDL08

.subckt INV_VDDL08_skew vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out in vsn vbn NMOS_VDDL08 l='2*lmda' w='5.5*lmda' ad='24.5*lmda*lmda'
+ as='24.5*lmda*lmda' pd='21*lmda' ps='21*lmda'
m2 out in vsp vbp PMOS_VDDL08 l='2*lmda' w='8.75*lmda' ad='153.125*lmda*lmda'
+ as='153.125*lmda*lmda' pd='52.5*lmda' ps='52.5*lmda'
.ends INV_VDDL08_skew

*(7) for low vdd = 0.7v, the Vt is scaled

.subckt INV_VDDL07 vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out in vsn vbn NMOS_VDDL07 l='2*lmda' w='3.5*lmda' ad='24.5*lmda*lmda'
+ as='24.5*lmda*lmda' pd='21*lmda' ps='21*lmda'
m2 out in vsp vbp PMOS_VDDL07 l='2*lmda' w='8.75*lmda' ad='153.125*lmda*lmda'
+ as='153.125*lmda*lmda' pd='52.5*lmda' ps='52.5*lmda'
.ends INV_VDDL07

.subckt INV_VDDL07_skew vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out in vsn vbn NMOS_VDDL07 l='2*lmda' w='5.5*lmda' ad='24.5*lmda*lmda'
+ as='24.5*lmda*lmda' pd='21*lmda' ps='21*lmda'
m2 out in vsp vbp PMOS_VDDL07 l='2*lmda' w='8.75*lmda' ad='153.125*lmda*lmda'
+ as='153.125*lmda*lmda' pd='52.5*lmda' ps='52.5*lmda'
.ends INV_VDDL07_skew


*--------------min width device----------

.subckt INV_min vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out in vsn vbn NMOS l='2*lmda' w='2*lmda' ad='14*lmda*lmda'
+ as='14*lmda*lmda' pd='12*lmda' ps='12*lmda'
m2 out in vsp vbp PMOS l='2*lmda' w='4*lmda' ad='70*lmda*lmda'
+ as='70*lmda*lmda' pd='24*lmda' ps='24*lmda'
.ends INV_min

.subckt INV_min5x vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out in vsn vbn NMOS l='2*lmda' w='10*lmda' ad='70*lmda*lmda'
+ as='70*lmda*lmda' pd='60*lmda' ps='60*lmda'
m2 out in vsp vbp PMOS l='2*lmda' w='20*lmda' ad='350*lmda*lmda'
+ as='350*lmda*lmda' pd='120*lmda' ps='120*lmda'
.ends INV_min5x

