*A inverter with twice driving strength
*scalable lamda design rule

* Fei Li
* 07/17/02

* (1) INV2x
* (2) INV2x_H
* (3) INV2x_EH
* (4) INV4x
* (5) INV5x
* (6) INV7x
* (7) INV10x
* (8) INV12x
* (9) INV15x
* (10) INV17x
* (11) INV20x
* (12) INV22x
* (13) INV25x
* (14) INV27x
* (15) INV30x

* (1) INV2x

* parameters
* =================
* lmda: design rule parameters (set in the file parameters.sp)
* v_supply: supply votage (set in the file parameters.sp)

* ports of the subckt and their functions
* =======================================
* vsp: source for PMOS transistors in the x-coupled inverters
*      usually connected to Vdd or virtual Vdd
* vbp: bulk for the PMOS transistors in the SRAM cell
* vsn: source for NMOS transistors in the x-coupled inverters
*      usually connected to Gnd or virtual Gnd
* vbn: bulk for the NMOS transistors in the SRAM cell
* in : input
* out: output


.subckt INV2x vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out in vsn vbn NMOS l='2*lmda' w='7*lmda' ad='49*lmda*lmda'
+ as='49*lmda*lmda' pd='42*lmda' ps='42*lmda'
m2 out in vsp vbp PMOS l='2*lmda' w='17.50*lmda' ad='306.25*lmda*lmda'
+ as='306.25*lmda*lmda' pd='105*lmda' ps='105*lmda'
.ends INV2x


*(2) INV2x_H

.subckt INV2x_H vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out in vsn vbn NMOS_H l='2*lmda' w='7*lmda' ad='49*lmda*lmda'
+ as='49*lmda*lmda' pd='42*lmda' ps='42*lmda'
m2 out in vsp vbp PMOS_H l='2*lmda' w='17.50*lmda' ad='306.25*lmda*lmda'
+ as='306.25*lmda*lmda' pd='105*lmda' ps='105*lmda'
.ends INV2x_H



*(3) INV2x_EH

.subckt INV2x_EH vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out in vsn vbn NMOS_EH l='2*lmda' w='7*lmda' ad='49*lmda*lmda'
+ as='49*lmda*lmda' pd='42*lmda' ps='42*lmda'
m2 out in vsp vbp PMOS_EH l='2*lmda' w='17.50*lmda' ad='306.25*lmda*lmda'
+ as='306.25*lmda*lmda' pd='105*lmda' ps='105*lmda'
.ends INV2x_EH


*(4) INV4x

.subckt INV4x vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out in vsn vbn NMOS l='2*lmda' w='14*lmda' ad='49*lmda*lmda'
+ as='49*lmda*lmda' pd='42*lmda' ps='42*lmda'
m2 out in vsp vbp PMOS l='2*lmda' w='35*lmda' ad='306.25*lmda*lmda'
+ as='306.25*lmda*lmda' pd='105*lmda' ps='105*lmda'
.ends INV4x


*(5) INV5x

.subckt INV5x vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out in vsn vbn NMOS l='2*lmda' w='17.5*lmda' ad='122.5*lmda*lmda'
+ as='122.5*lmda*lmda' pd='105*lmda' ps='105*lmda'
m2 out in vsp vbp PMOS l='2*lmda' w='43.75*lmda' ad='765.625*lmda*lmda'
+ as='765.625*lmda*lmda' pd='262.5*lmda' ps='262.5*lmda'
.ends INV5x

*(6) INV7x

.subckt INV7x vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out in vsn vbn NMOS l='2*lmda' w='24.5*lmda' ad='171.5*lmda*lmda'
+ as='171.5*lmda*lmda' pd='147*lmda' ps='147*lmda'
m2 out in vsp vbp PMOS l='2*lmda' w='61.25*lmda' ad='1071.87*lmda*lmda'
+ as='1071.87*lmda*lmda' pd='367.5*lmda' ps='367.5*lmda'
.ends INV7x


*(7) INV10x

.subckt INV10x vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out in vsn vbn NMOS l='2*lmda' w='35*lmda' ad='245*lmda*lmda'
+ as='245*lmda*lmda' pd='210*lmda' ps='210*lmda'
m2 out in vsp vbp PMOS l='2*lmda' w='87.5*lmda' ad='1531.25*lmda*lmda'
+ as='1531.25*lmda*lmda' pd='525*lmda' ps='525*lmda'
.ends INV10x

*(8) INV12x

.subckt INV12x vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out in vsn vbn NMOS l='2*lmda' w='42*lmda' ad='294*lmda*lmda'
+ as='294*lmda*lmda' pd='252*lmda' ps='252*lmda'
m2 out in vsp vbp PMOS l='2*lmda' w='105*lmda' ad='1837.5*lmda*lmda'
+ as='1837.5*lmda*lmda' pd='630*lmda' ps='630*lmda'
.ends INV12x

*(9) INV15x

.subckt INV15x vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out in vsn vbn NMOS l='2*lmda' w='52.5*lmda' ad='367.5*lmda*lmda'
+ as='367.5*lmda*lmda' pd='315*lmda' ps='315*lmda'
m2 out in vsp vbp PMOS l='2*lmda' w='131.25*lmda' ad='2296.875*lmda*lmda'
+ as='2296.875*lmda*lmda' pd='787.5*lmda' ps='787.5*lmda'
.ends INV15x

*(10) INV17x

.subckt INV17x vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out in vsn vbn NMOS l='2*lmda' w='59.5*lmda' ad='416.5*lmda*lmda'
+ as='416.5*lmda*lmda' pd='357*lmda' ps='357*lmda'
m2 out in vsp vbp PMOS l='2*lmda' w='148.75*lmda' ad='2603.125*lmda*lmda'
+ as='2603.125*lmda*lmda' pd='892.5*lmda' ps='892.5*lmda'
.ends INV17x

*(11) INV20x

.subckt INV20x vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out in vsn vbn NMOS l='2*lmda' w='70*lmda' ad='490*lmda*lmda'
+ as='490*lmda*lmda' pd='420*lmda' ps='420*lmda'
m2 out in vsp vbp PMOS l='2*lmda' w='175*lmda' ad='3062.5*lmda*lmda'
+ as='3062.5*lmda*lmda' pd='1050*lmda' ps='1050*lmda'
.ends INV20x


*(12) INV22x

.subckt INV22x vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out in vsn vbn NMOS l='2*lmda' w='77*lmda' ad='539*lmda*lmda'
+ as='539*lmda*lmda' pd='462*lmda' ps='462*lmda'
m2 out in vsp vbp PMOS l='2*lmda' w='192.5*lmda' ad='3368.75*lmda*lmda'
+ as='3368.75*lmda*lmda' pd='1155*lmda' ps='1155*lmda'
.ends INV22x


*(13) INV25x

.subckt INV25x vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out in vsn vbn NMOS l='2*lmda' w='87.5*lmda' ad='612.5*lmda*lmda'
+ as='612.5*lmda*lmda' pd='525*lmda' ps='525*lmda'
m2 out in vsp vbp PMOS l='2*lmda' w='218.75*lmda' ad='3828.125*lmda*lmda'
+ as='3828.125*lmda*lmda' pd='1312.5*lmda' ps='1312.5*lmda'
.ends INV25x


*(14) INV27x

.subckt INV27x vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out in vsn vbn NMOS l='2*lmda' w='94.5*lmda' ad='661.5*lmda*lmda'
+ as='661.5*lmda*lmda' pd='567*lmda' ps='567*lmda'
m2 out in vsp vbp PMOS l='2*lmda' w='236.25*lmda' ad='4134.375*lmda*lmda'
+ as='4134.375*lmda*lmda' pd='1417.5*lmda' ps='1417.5*lmda'
.ends INV27x


*(15) INV30x

.subckt INV30x vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out in vsn vbn NMOS l='2*lmda' w='105*lmda' ad='735*lmda*lmda'
+ as='735*lmda*lmda' pd='630*lmda' ps='630*lmda'
m2 out in vsp vbp PMOS l='2*lmda' w='262.5*lmda' ad='4593.75*lmda*lmda'
+ as='4593.75*lmda*lmda' pd='1575*lmda' ps='1575*lmda'
.ends INV30x


*(16) INV3x

.subckt INV3x vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out in vsn vbn NMOS l='2*lmda' w='10.5*lmda' ad='73.5*lmda*lmda'
+ as='73.5*lmda*lmda' pd='63*lmda' ps='63*lmda'
m2 out in vsp vbp PMOS l='2*lmda' w='26.25*lmda' ad='459.375*lmda*lmda'
+ as='459.375*lmda*lmda' pd='157.5*lmda' ps='157.5*lmda'
.ends INV3x

*(17) INV9x

.subckt INV9x vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out in vsn vbn NMOS l='2*lmda' w='31.5*lmda' ad='220.5*lmda*lmda'
+ as='220.5*lmda*lmda' pd='189*lmda' ps='189*lmda'
m2 out in vsp vbp PMOS l='2*lmda' w='78.75*lmda' ad='1378.125*lmda*lmda'
+ as='1378.125*lmda*lmda' pd='472.5*lmda' ps='472.5*lmda'
.ends INV9x

*(18) INV35x

.subckt INV35x vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out in vsn vbn NMOS l='2*lmda' w='122.5*lmda' ad='857.5*lmda*lmda'
+ as='857.5*lmda*lmda' pd='735*lmda' ps='735*lmda'
m2 out in vsp vbp PMOS l='2*lmda' w='306.25*lmda' ad='5359.375*lmda*lmda'
+ as='5359.375*lmda*lmda' pd='1837.5*lmda' ps='1837.5*lmda'
.ends INV35x

*(19) INV40x

.subckt INV40x vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out in vsn vbn NMOS l='2*lmda' w='140*lmda' ad='980*lmda*lmda'
+ as='980*lmda*lmda' pd='840*lmda' ps='840*lmda'
m2 out in vsp vbp PMOS l='2*lmda' w='350*lmda' ad='6125*lmda*lmda'
+ as='6125*lmda*lmda' pd='2100*lmda' ps='2100*lmda'
.ends INV40x

* **************************************************************

* (I) INV2x_VDDL10

* parameters
* =================
* lmda: design rule parameters (set in the file parameters.sp)
* v_supply: supply votage (set in the file parameters.sp)

* ports of the subckt and their functions
* =======================================
* vsp: source for PMOS transistors in the x-coupled inverters
*      usually connected to Vdd or virtual Vdd
* vbp: bulk for the PMOS transistors in the SRAM cell
* vsn: source for NMOS transistors in the x-coupled inverters
*      usually connected to Gnd or virtual Gnd
* vbn: bulk for the NMOS transistors in the SRAM cell
* in : input
* out: output


.subckt INV2x_VDDL10 vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out in vsn vbn NMOS_VDDL10 l='2*lmda' w='7*lmda' ad='49*lmda*lmda'
+ as='49*lmda*lmda' pd='42*lmda' ps='42*lmda'
m2 out in vsp vbp PMOS_VDDL10 l='2*lmda' w='17.50*lmda' ad='306.25*lmda*lmda'
+ as='306.25*lmda*lmda' pd='105*lmda' ps='105*lmda'
.ends INV2x_VDDL10

* (II) INV2x_VDDL09

* parameters
* =================
* lmda: design rule parameters (set in the file parameters.sp)
* v_supply: supply votage (set in the file parameters.sp)

* ports of the subckt and their functions
* =======================================
* vsp: source for PMOS transistors in the x-coupled inverters
*      usually connected to Vdd or virtual Vdd
* vbp: bulk for the PMOS transistors in the SRAM cell
* vsn: source for NMOS transistors in the x-coupled inverters
*      usually connected to Gnd or virtual Gnd
* vbn: bulk for the NMOS transistors in the SRAM cell
* in : input
* out: output


.subckt INV2x_VDDL09 vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out in vsn vbn NMOS_VDDL09 l='2*lmda' w='7*lmda' ad='49*lmda*lmda'
+ as='49*lmda*lmda' pd='42*lmda' ps='42*lmda'
m2 out in vsp vbp PMOS_VDDL09 l='2*lmda' w='17.50*lmda' ad='306.25*lmda*lmda'
+ as='306.25*lmda*lmda' pd='105*lmda' ps='105*lmda'
.ends INV2x_VDDL09

* (III) INV2x_VDDL08

* parameters
* =================
* lmda: design rule parameters (set in the file parameters.sp)
* v_supply: supply votage (set in the file parameters.sp)

* ports of the subckt and their functions
* =======================================
* vsp: source for PMOS transistors in the x-coupled inverters
*      usually connected to Vdd or virtual Vdd
* vbp: bulk for the PMOS transistors in the SRAM cell
* vsn: source for NMOS transistors in the x-coupled inverters
*      usually connected to Gnd or virtual Gnd
* vbn: bulk for the NMOS transistors in the SRAM cell
* in : input
* out: output


.subckt INV2x_VDDL08 vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out in vsn vbn NMOS_VDDL08 l='2*lmda' w='7*lmda' ad='49*lmda*lmda'
+ as='49*lmda*lmda' pd='42*lmda' ps='42*lmda'
m2 out in vsp vbp PMOS_VDDL08 l='2*lmda' w='17.50*lmda' ad='306.25*lmda*lmda'
+ as='306.25*lmda*lmda' pd='105*lmda' ps='105*lmda'
.ends INV2x_VDDL08

* (IV) INV2x_VDDL07

* parameters
* =================
* lmda: design rule parameters (set in the file parameters.sp)
* v_supply: supply votage (set in the file parameters.sp)

* ports of the subckt and their functions
* =======================================
* vsp: source for PMOS transistors in the x-coupled inverters
*      usually connected to Vdd or virtual Vdd
* vbp: bulk for the PMOS transistors in the SRAM cell
* vsn: source for NMOS transistors in the x-coupled inverters
*      usually connected to Gnd or virtual Gnd
* vbn: bulk for the NMOS transistors in the SRAM cell
* in : input
* out: output


.subckt INV2x_VDDL07 vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out in vsn vbn NMOS_VDDL07 l='2*lmda' w='7*lmda' ad='49*lmda*lmda'
+ as='49*lmda*lmda' pd='42*lmda' ps='42*lmda'
m2 out in vsp vbp PMOS_VDDL07 l='2*lmda' w='17.50*lmda' ad='306.25*lmda*lmda'
+ as='306.25*lmda*lmda' pd='105*lmda' ps='105*lmda'
.ends INV2x_VDDL07

* () INV4x_VDDL10

.subckt INV4x_VDDL10 vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out in vsn vbn NMOS_VDDL10 l='2*lmda' w='14*lmda' ad='49*lmda*lmda'
+ as='49*lmda*lmda' pd='42*lmda' ps='42*lmda'
m2 out in vsp vbp PMOS_VDDL10 l='2*lmda' w='35*lmda' ad='306.25*lmda*lmda'
+ as='306.25*lmda*lmda' pd='105*lmda' ps='105*lmda'
.ends INV4x_VDDL10

* () INV4x_VDDL09

.subckt INV4x_VDDL09 vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out in vsn vbn NMOS_VDDL09 l='2*lmda' w='14*lmda' ad='49*lmda*lmda'
+ as='49*lmda*lmda' pd='42*lmda' ps='42*lmda'
m2 out in vsp vbp PMOS_VDDL09 l='2*lmda' w='35*lmda' ad='306.25*lmda*lmda'
+ as='306.25*lmda*lmda' pd='105*lmda' ps='105*lmda'
.ends INV4x_VDDL09


* () INV4x_VDDL08

.subckt INV4x_VDDL08 vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out in vsn vbn NMOS_VDDL08 l='2*lmda' w='14*lmda' ad='49*lmda*lmda'
+ as='49*lmda*lmda' pd='42*lmda' ps='42*lmda'
m2 out in vsp vbp PMOS_VDDL08 l='2*lmda' w='35*lmda' ad='306.25*lmda*lmda'
+ as='306.25*lmda*lmda' pd='105*lmda' ps='105*lmda'
.ends INV4x_VDDL08

*() INV5x_VDDL10

.subckt INV5x_VDDL10 vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out in vsn vbn NMOS_VDDL10 l='2*lmda' w='17.5*lmda' ad='122.5*lmda*lmda'
+ as='122.5*lmda*lmda' pd='105*lmda' ps='105*lmda'
m2 out in vsp vbp PMOS_VDDL10 l='2*lmda' w='43.75*lmda' ad='765.625*lmda*lmda'
+ as='765.625*lmda*lmda' pd='262.5*lmda' ps='262.5*lmda'
.ends INV5x_VDDL10

*() INV5x_VDDL09

.subckt INV5x_VDDL09 vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out in vsn vbn NMOS_VDDL09 l='2*lmda' w='17.5*lmda' ad='122.5*lmda*lmda'
+ as='122.5*lmda*lmda' pd='105*lmda' ps='105*lmda'
m2 out in vsp vbp PMOS_VDDL09 l='2*lmda' w='43.75*lmda' ad='765.625*lmda*lmda'
+ as='765.625*lmda*lmda' pd='262.5*lmda' ps='262.5*lmda'
.ends INV5x_VDDL09

*() INV5x_VDDL08

.subckt INV5x_VDDL08 vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out in vsn vbn NMOS_VDDL08 l='2*lmda' w='17.5*lmda' ad='122.5*lmda*lmda'
+ as='122.5*lmda*lmda' pd='105*lmda' ps='105*lmda'
m2 out in vsp vbp PMOS_VDDL08 l='2*lmda' w='43.75*lmda' ad='765.625*lmda*lmda'
+ as='765.625*lmda*lmda' pd='262.5*lmda' ps='262.5*lmda'
.ends INV5x_VDDL08

*() INV7x_VDDL10

.subckt INV7x_VDDL10 vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out in vsn vbn NMOS_VDDL10 l='2*lmda' w='24.5*lmda' ad='171.5*lmda*lmda'
+ as='171.5*lmda*lmda' pd='147*lmda' ps='147*lmda'
m2 out in vsp vbp PMOS_VDDL10 l='2*lmda' w='61.25*lmda' ad='1071.87*lmda*lmda'
+ as='1071.87*lmda*lmda' pd='367.5*lmda' ps='367.5*lmda'
.ends INV7x_VDDL10

*() INV7x_VDDL09

.subckt INV7x_VDDL09 vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out in vsn vbn NMOS_VDDL09 l='2*lmda' w='24.5*lmda' ad='171.5*lmda*lmda'
+ as='171.5*lmda*lmda' pd='147*lmda' ps='147*lmda'
m2 out in vsp vbp PMOS_VDDL09 l='2*lmda' w='61.25*lmda' ad='1071.87*lmda*lmda'
+ as='1071.87*lmda*lmda' pd='367.5*lmda' ps='367.5*lmda'
.ends INV7x_VDDL09

*() INV7x_VDDL08

.subckt INV7x_VDDL08 vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out in vsn vbn NMOS_VDDL08 l='2*lmda' w='24.5*lmda' ad='171.5*lmda*lmda'
+ as='171.5*lmda*lmda' pd='147*lmda' ps='147*lmda'
m2 out in vsp vbp PMOS_VDDL08 l='2*lmda' w='61.25*lmda' ad='1071.87*lmda*lmda'
+ as='1071.87*lmda*lmda' pd='367.5*lmda' ps='367.5*lmda'
.ends INV7x_VDDL08

*() INV10x_VDDL10

.subckt INV10x_VDDL10 vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out in vsn vbn NMOS_VDDL10 l='2*lmda' w='35*lmda' ad='245*lmda*lmda'
+ as='245*lmda*lmda' pd='210*lmda' ps='210*lmda'
m2 out in vsp vbp PMOS_VDDL10 l='2*lmda' w='87.5*lmda' ad='1531.25*lmda*lmda'
+ as='1531.25*lmda*lmda' pd='525*lmda' ps='525*lmda'
.ends INV10x_VDDL10

*() INV10x_VDDL09

.subckt INV10x_VDDL09 vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out in vsn vbn NMOS_VDDL09 l='2*lmda' w='35*lmda' ad='245*lmda*lmda'
+ as='245*lmda*lmda' pd='210*lmda' ps='210*lmda'
m2 out in vsp vbp PMOS_VDDL09 l='2*lmda' w='87.5*lmda' ad='1531.25*lmda*lmda'
+ as='1531.25*lmda*lmda' pd='525*lmda' ps='525*lmda'
.ends INV10x_VDDL09

*() INV10x_VDDL08

.subckt INV10x_VDDL08 vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out in vsn vbn NMOS_VDDL08 l='2*lmda' w='35*lmda' ad='245*lmda*lmda'
+ as='245*lmda*lmda' pd='210*lmda' ps='210*lmda'
m2 out in vsp vbp PMOS_VDDL08 l='2*lmda' w='87.5*lmda' ad='1531.25*lmda*lmda'
+ as='1531.25*lmda*lmda' pd='525*lmda' ps='525*lmda'
.ends INV10x_VDDL08

*() INV12x_VDDL10

.subckt INV12x_VDDL10 vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out in vsn vbn NMOS_VDDL10 l='2*lmda' w='42*lmda' ad='294*lmda*lmda'
+ as='294*lmda*lmda' pd='252*lmda' ps='252*lmda'
m2 out in vsp vbp PMOS_VDDL10 l='2*lmda' w='105*lmda' ad='1837.5*lmda*lmda'
+ as='1837.5*lmda*lmda' pd='630*lmda' ps='630*lmda'
.ends INV12x_VDDL10

*() INV12x_VDDL09

.subckt INV12x_VDDL09 vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out in vsn vbn NMOS_VDDL09 l='2*lmda' w='42*lmda' ad='294*lmda*lmda'
+ as='294*lmda*lmda' pd='252*lmda' ps='252*lmda'
m2 out in vsp vbp PMOS_VDDL09 l='2*lmda' w='105*lmda' ad='1837.5*lmda*lmda'
+ as='1837.5*lmda*lmda' pd='630*lmda' ps='630*lmda'
.ends INV12x_VDDL09

*() INV12x_VDDL08

.subckt INV12x_VDDL08 vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out in vsn vbn NMOS_VDDL08 l='2*lmda' w='42*lmda' ad='294*lmda*lmda'
+ as='294*lmda*lmda' pd='252*lmda' ps='252*lmda'
m2 out in vsp vbp PMOS_VDDL08 l='2*lmda' w='105*lmda' ad='1837.5*lmda*lmda'
+ as='1837.5*lmda*lmda' pd='630*lmda' ps='630*lmda'
.ends INV12x_VDDL08

*() INV15x_VDDL10

.subckt INV15x_VDDL10 vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out in vsn vbn NMOS_VDDL10 l='2*lmda' w='52.5*lmda' ad='367.5*lmda*lmda'
+ as='367.5*lmda*lmda' pd='315*lmda' ps='315*lmda'
m2 out in vsp vbp PMOS_VDDL10 l='2*lmda' w='131.25*lmda' ad='2296.875*lmda*lmda'
+ as='2296.875*lmda*lmda' pd='787.5*lmda' ps='787.5*lmda'
.ends INV15x_VDDL10

*() INV15x_VDDL09

.subckt INV15x_VDDL09 vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out in vsn vbn NMOS_VDDL09 l='2*lmda' w='52.5*lmda' ad='367.5*lmda*lmda'
+ as='367.5*lmda*lmda' pd='315*lmda' ps='315*lmda'
m2 out in vsp vbp PMOS_VDDL09 l='2*lmda' w='131.25*lmda' ad='2296.875*lmda*lmda'
+ as='2296.875*lmda*lmda' pd='787.5*lmda' ps='787.5*lmda'
.ends INV15x_VDDL09

*() INV15x_VDDL08

.subckt INV15x_VDDL08 vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out in vsn vbn NMOS_VDDL08 l='2*lmda' w='52.5*lmda' ad='367.5*lmda*lmda'
+ as='367.5*lmda*lmda' pd='315*lmda' ps='315*lmda'
m2 out in vsp vbp PMOS_VDDL08 l='2*lmda' w='131.25*lmda' ad='2296.875*lmda*lmda'
+ as='2296.875*lmda*lmda' pd='787.5*lmda' ps='787.5*lmda'
.ends INV15x_VDDL08

*() INV17x_VDDL10

.subckt INV17x_VDDL10 vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out in vsn vbn NMOS_VDDL10 l='2*lmda' w='59.5*lmda' ad='416.5*lmda*lmda'
+ as='416.5*lmda*lmda' pd='357*lmda' ps='357*lmda'
m2 out in vsp vbp PMOS_VDDL10 l='2*lmda' w='148.75*lmda' ad='2603.125*lmda*lmda'
+ as='2603.125*lmda*lmda' pd='892.5*lmda' ps='892.5*lmda'
.ends INV17x_VDDL10

*() INV17x_VDDL09

.subckt INV17x_VDDL09 vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out in vsn vbn NMOS_VDDL09 l='2*lmda' w='59.5*lmda' ad='416.5*lmda*lmda'
+ as='416.5*lmda*lmda' pd='357*lmda' ps='357*lmda'
m2 out in vsp vbp PMOS_VDDL09 l='2*lmda' w='148.75*lmda' ad='2603.125*lmda*lmda'
+ as='2603.125*lmda*lmda' pd='892.5*lmda' ps='892.5*lmda'
.ends INV17x_VDDL09

*() INV17x_VDDL08

.subckt INV17x_VDDL08 vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out in vsn vbn NMOS_VDDL08 l='2*lmda' w='59.5*lmda' ad='416.5*lmda*lmda'
+ as='416.5*lmda*lmda' pd='357*lmda' ps='357*lmda'
m2 out in vsp vbp PMOS_VDDL08 l='2*lmda' w='148.75*lmda' ad='2603.125*lmda*lmda'
+ as='2603.125*lmda*lmda' pd='892.5*lmda' ps='892.5*lmda'
.ends INV17x_VDDL08

*() INV20x_VDDL10

.subckt INV20x_VDDL10 vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out in vsn vbn NMOS_VDDL10 l='2*lmda' w='70*lmda' ad='490*lmda*lmda'
+ as='490*lmda*lmda' pd='420*lmda' ps='420*lmda'
m2 out in vsp vbp PMOS_VDDL10 l='2*lmda' w='175*lmda' ad='3062.5*lmda*lmda'
+ as='3062.5*lmda*lmda' pd='1050*lmda' ps='1050*lmda'
.ends INV20x_VDDL10

*() INV20x_VDDL09

.subckt INV20x_VDDL09 vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out in vsn vbn NMOS_VDDL09 l='2*lmda' w='70*lmda' ad='490*lmda*lmda'
+ as='490*lmda*lmda' pd='420*lmda' ps='420*lmda'
m2 out in vsp vbp PMOS_VDDL09 l='2*lmda' w='175*lmda' ad='3062.5*lmda*lmda'
+ as='3062.5*lmda*lmda' pd='1050*lmda' ps='1050*lmda'
.ends INV20x_VDDL09

*() INV20x_VDDL08

.subckt INV20x_VDDL08 vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out in vsn vbn NMOS_VDDL08 l='2*lmda' w='70*lmda' ad='490*lmda*lmda'
+ as='490*lmda*lmda' pd='420*lmda' ps='420*lmda'
m2 out in vsp vbp PMOS_VDDL08 l='2*lmda' w='175*lmda' ad='3062.5*lmda*lmda'
+ as='3062.5*lmda*lmda' pd='1050*lmda' ps='1050*lmda'
.ends INV20x_VDDL08

*() INV22x_VDDL10

.subckt INV22x_VDDL10 vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out in vsn vbn NMOS_VDDL10 l='2*lmda' w='77*lmda' ad='539*lmda*lmda'
+ as='539*lmda*lmda' pd='462*lmda' ps='462*lmda'
m2 out in vsp vbp PMOS_VDDL10 l='2*lmda' w='192.5*lmda' ad='3368.75*lmda*lmda'
+ as='3368.75*lmda*lmda' pd='1155*lmda' ps='1155*lmda'
.ends INV22x_VDDL10

*() INV22x_VDDL09

.subckt INV22x_VDDL09 vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out in vsn vbn NMOS_VDDL09 l='2*lmda' w='77*lmda' ad='539*lmda*lmda'
+ as='539*lmda*lmda' pd='462*lmda' ps='462*lmda'
m2 out in vsp vbp PMOS_VDDL09 l='2*lmda' w='192.5*lmda' ad='3368.75*lmda*lmda'
+ as='3368.75*lmda*lmda' pd='1155*lmda' ps='1155*lmda'
.ends INV22x_VDDL09

*() INV22x_VDDL08

.subckt INV22x_VDDL08 vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out in vsn vbn NMOS_VDDL08 l='2*lmda' w='77*lmda' ad='539*lmda*lmda'
+ as='539*lmda*lmda' pd='462*lmda' ps='462*lmda'
m2 out in vsp vbp PMOS_VDDL08 l='2*lmda' w='192.5*lmda' ad='3368.75*lmda*lmda'
+ as='3368.75*lmda*lmda' pd='1155*lmda' ps='1155*lmda'
.ends INV22x_VDDL08

*() INV25x_VDDL10

.subckt INV25x_VDDL10 vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out in vsn vbn NMOS_VDDL10 l='2*lmda' w='87.5*lmda' ad='612.5*lmda*lmda'
+ as='612.5*lmda*lmda' pd='525*lmda' ps='525*lmda'
m2 out in vsp vbp PMOS_VDDL10 l='2*lmda' w='218.75*lmda' ad='3828.125*lmda*lmda'
+ as='3828.125*lmda*lmda' pd='1312.5*lmda' ps='1312.5*lmda'
.ends INV25x_VDDL10

*() INV25x_VDDL09

.subckt INV25x_VDDL09 vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out in vsn vbn NMOS_VDDL09 l='2*lmda' w='87.5*lmda' ad='612.5*lmda*lmda'
+ as='612.5*lmda*lmda' pd='525*lmda' ps='525*lmda'
m2 out in vsp vbp PMOS_VDDL09 l='2*lmda' w='218.75*lmda' ad='3828.125*lmda*lmda'
+ as='3828.125*lmda*lmda' pd='1312.5*lmda' ps='1312.5*lmda'
.ends INV25x_VDDL09

*() INV25x_VDDL08

.subckt INV25x_VDDL08 vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out in vsn vbn NMOS_VDDL08 l='2*lmda' w='87.5*lmda' ad='612.5*lmda*lmda'
+ as='612.5*lmda*lmda' pd='525*lmda' ps='525*lmda'
m2 out in vsp vbp PMOS_VDDL08 l='2*lmda' w='218.75*lmda' ad='3828.125*lmda*lmda'
+ as='3828.125*lmda*lmda' pd='1312.5*lmda' ps='1312.5*lmda'
.ends INV25x_VDDL08

*() INV27x_VDDL10

.subckt INV27x_VDDL10 vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out in vsn vbn NMOS_VDDL10 l='2*lmda' w='94.5*lmda' ad='661.5*lmda*lmda'
+ as='661.5*lmda*lmda' pd='567*lmda' ps='567*lmda'
m2 out in vsp vbp PMOS_VDDL10 l='2*lmda' w='236.25*lmda' ad='4134.375*lmda*lmda'
+ as='4134.375*lmda*lmda' pd='1417.5*lmda' ps='1417.5*lmda'
.ends INV27x_VDDL10

*() INV27x_VDDL09

.subckt INV27x_VDDL09 vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out in vsn vbn NMOS_VDDL09 l='2*lmda' w='94.5*lmda' ad='661.5*lmda*lmda'
+ as='661.5*lmda*lmda' pd='567*lmda' ps='567*lmda'
m2 out in vsp vbp PMOS_VDDL09 l='2*lmda' w='236.25*lmda' ad='4134.375*lmda*lmda'
+ as='4134.375*lmda*lmda' pd='1417.5*lmda' ps='1417.5*lmda'
.ends INV27x_VDDL09

*() INV27x_VDDL08

.subckt INV27x_VDDL08 vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out in vsn vbn NMOS_VDDL08 l='2*lmda' w='94.5*lmda' ad='661.5*lmda*lmda'
+ as='661.5*lmda*lmda' pd='567*lmda' ps='567*lmda'
m2 out in vsp vbp PMOS_VDDL08 l='2*lmda' w='236.25*lmda' ad='4134.375*lmda*lmda'
+ as='4134.375*lmda*lmda' pd='1417.5*lmda' ps='1417.5*lmda'
.ends INV27x_VDDL08

*() INV30x_VDDL10

.subckt INV30x_VDDL10 vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out in vsn vbn NMOS_VDDL10 l='2*lmda' w='105*lmda' ad='735*lmda*lmda'
+ as='735*lmda*lmda' pd='630*lmda' ps='630*lmda'
m2 out in vsp vbp PMOS_VDDL10 l='2*lmda' w='262.5*lmda' ad='4593.75*lmda*lmda'
+ as='4593.75*lmda*lmda' pd='1575*lmda' ps='1575*lmda'
.ends INV30x_VDDL10

*() INV30x_VDDL09

.subckt INV30x_VDDL09 vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out in vsn vbn NMOS_VDDL09 l='2*lmda' w='105*lmda' ad='735*lmda*lmda'
+ as='735*lmda*lmda' pd='630*lmda' ps='630*lmda'
m2 out in vsp vbp PMOS_VDDL09 l='2*lmda' w='262.5*lmda' ad='4593.75*lmda*lmda'
+ as='4593.75*lmda*lmda' pd='1575*lmda' ps='1575*lmda'
.ends INV30x_VDDL09

*() INV30x_VDDL08

.subckt INV30x_VDDL08 vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out in vsn vbn NMOS_VDDL08 l='2*lmda' w='105*lmda' ad='735*lmda*lmda'
+ as='735*lmda*lmda' pd='630*lmda' ps='630*lmda'
m2 out in vsp vbp PMOS_VDDL08 l='2*lmda' w='262.5*lmda' ad='4593.75*lmda*lmda'
+ as='4593.75*lmda*lmda' pd='1575*lmda' ps='1575*lmda'
.ends INV30x_VDDL08

*() INV35x_VDDL10

.subckt INV35x_VDDL10 vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out in vsn vbn NMOS_VDDL10 l='2*lmda' w='122.5*lmda' ad='857.5*lmda*lmda'
+ as='857.5*lmda*lmda' pd='735*lmda' ps='735*lmda'
m2 out in vsp vbp PMOS_VDDL10 l='2*lmda' w='306.25*lmda' ad='5359.375*lmda*lmda'
+ as='5359.375*lmda*lmda' pd='1837.5*lmda' ps='1837.5*lmda'
.ends INV35x_VDDL10

*() INV35x_VDDL09

.subckt INV35x_VDDL09 vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out in vsn vbn NMOS_VDDL09 l='2*lmda' w='122.5*lmda' ad='857.5*lmda*lmda'
+ as='857.5*lmda*lmda' pd='735*lmda' ps='735*lmda'
m2 out in vsp vbp PMOS_VDDL09 l='2*lmda' w='306.25*lmda' ad='5359.375*lmda*lmda'
+ as='5359.375*lmda*lmda' pd='1837.5*lmda' ps='1837.5*lmda'
.ends INV35x_VDDL09

*() INV35x_VDDL08

.subckt INV35x_VDDL08 vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out in vsn vbn NMOS_VDDL08 l='2*lmda' w='122.5*lmda' ad='857.5*lmda*lmda'
+ as='857.5*lmda*lmda' pd='735*lmda' ps='735*lmda'
m2 out in vsp vbp PMOS_VDDL08 l='2*lmda' w='306.25*lmda' ad='5359.375*lmda*lmda'
+ as='5359.375*lmda*lmda' pd='1837.5*lmda' ps='1837.5*lmda'
.ends INV35x_VDDL08

*() INV40x_VDDL10

.subckt INV40x_VDDL10 vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out in vsn vbn NMOS_VDDL10 l='2*lmda' w='140*lmda' ad='980*lmda*lmda'
+ as='980*lmda*lmda' pd='840*lmda' ps='840*lmda'
m2 out in vsp vbp PMOS_VDDL10 l='2*lmda' w='350*lmda' ad='6125*lmda*lmda'
+ as='6125*lmda*lmda' pd='2100*lmda' ps='2100*lmda'
.ends INV40x_VDDL10

*() INV40x_VDDL09

.subckt INV40x_VDDL09 vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out in vsn vbn NMOS_VDDL09 l='2*lmda' w='140*lmda' ad='980*lmda*lmda'
+ as='980*lmda*lmda' pd='840*lmda' ps='840*lmda'
m2 out in vsp vbp PMOS_VDDL09 l='2*lmda' w='350*lmda' ad='6125*lmda*lmda'
+ as='6125*lmda*lmda' pd='2100*lmda' ps='2100*lmda'
.ends INV40x_VDDL09

*() INV40x_VDDL08

.subckt INV40x_VDDL08 vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out in vsn vbn NMOS_VDDL08 l='2*lmda' w='140*lmda' ad='980*lmda*lmda'
+ as='980*lmda*lmda' pd='840*lmda' ps='840*lmda'
m2 out in vsp vbp PMOS_VDDL08 l='2*lmda' w='350*lmda' ad='6125*lmda*lmda'
+ as='6125*lmda*lmda' pd='2100*lmda' ps='2100*lmda'
.ends INV40x_VDDL08

*() INV3x_VDDL10

.subckt INV3x_VDDL10 vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out in vsn vbn NMOS_VDDL10 l='2*lmda' w='10.5*lmda' ad='73.5*lmda*lmda'
+ as='73.5*lmda*lmda' pd='63*lmda' ps='63*lmda'
m2 out in vsp vbp PMOS_VDDL10 l='2*lmda' w='26.25*lmda' ad='459.375*lmda*lmda'
+ as='459.375*lmda*lmda' pd='157.5*lmda' ps='157.5*lmda'
.ends INV3x_VDDL10

*() INV3x_VDDL09

.subckt INV3x_VDDL09 vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out in vsn vbn NMOS_VDDL09 l='2*lmda' w='10.5*lmda' ad='73.5*lmda*lmda'
+ as='73.5*lmda*lmda' pd='63*lmda' ps='63*lmda'
m2 out in vsp vbp PMOS_VDDL09 l='2*lmda' w='26.25*lmda' ad='459.375*lmda*lmda'
+ as='459.375*lmda*lmda' pd='157.5*lmda' ps='157.5*lmda'
.ends INV3x_VDDL09

*() INV3x_VDDL08

.subckt INV3x_VDDL08 vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out in vsn vbn NMOS_VDDL08 l='2*lmda' w='10.5*lmda' ad='73.5*lmda*lmda'
+ as='73.5*lmda*lmda' pd='63*lmda' ps='63*lmda'
m2 out in vsp vbp PMOS_VDDL08 l='2*lmda' w='26.25*lmda' ad='459.375*lmda*lmda'
+ as='459.375*lmda*lmda' pd='157.5*lmda' ps='157.5*lmda'
.ends INV3x_VDDL08

*() INV9x_VDDL10

.subckt INV9x_VDDL10 vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out in vsn vbn NMOS_VDDL10 l='2*lmda' w='31.5*lmda' ad='220.5*lmda*lmda'
+ as='220.5*lmda*lmda' pd='189*lmda' ps='189*lmda'
m2 out in vsp vbp PMOS_VDDL10 l='2*lmda' w='78.75*lmda' ad='1378.125*lmda*lmda'
+ as='1378.125*lmda*lmda' pd='472.5*lmda' ps='472.5*lmda'
.ends INV9x_VDDL10

*() INV9x_VDDL09

.subckt INV9x_VDDL09 vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out in vsn vbn NMOS_VDDL09 l='2*lmda' w='31.5*lmda' ad='220.5*lmda*lmda'
+ as='220.5*lmda*lmda' pd='189*lmda' ps='189*lmda'
m2 out in vsp vbp PMOS_VDDL09 l='2*lmda' w='78.75*lmda' ad='1378.125*lmda*lmda'
+ as='1378.125*lmda*lmda' pd='472.5*lmda' ps='472.5*lmda'
.ends INV9x_VDDL09

*() INV9x_VDDL08

.subckt INV9x_VDDL08 vsp vbp vsn vbn in out
*For 0.10um technology, l= 2*lmda = 0.10um
** eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out in vsn vbn NMOS_VDDL08 l='2*lmda' w='31.5*lmda' ad='220.5*lmda*lmda'
+ as='220.5*lmda*lmda' pd='189*lmda' ps='189*lmda'
m2 out in vsp vbp PMOS_VDDL08 l='2*lmda' w='78.75*lmda' ad='1378.125*lmda*lmda'
+ as='1378.125*lmda*lmda' pd='472.5*lmda' ps='472.5*lmda'
.ends INV9x_VDDL08

