*0.10u technology

* Fei LI
* May 20, 2003
* subcircuits for LUTs

.subckt LUT4 vsp vbp vsn vbn in0 in1 in2 in3 lut_out
* -----------------------------------------------------------

* vsp: source for PMOS transistors in the x-coupled inverters
*      usually connected to Vdd or virtual Vdd
* vbp: bulk for the PMOS transistors in the SRAM cell
* vsn: source for NMOS transistors in the x-coupled inverters
*      usually connected to Gnd or virtual Gnd
* vbn: bulk for the NMOS transistors in the SRAM cell
* in0, in1, in2, in3: LUT inputs
* lut_out           : LUT output
* vdd_node          : global node for vdd


x1 vsp vbp vsn vbn i0 i1 i2 i3 i4 i5 i6 i7
+ i8 i9 i10 i11 i12 i13 i14 i15 in0 in1 in2 in3 out MUX16_1_BUF

* mux should be followed by a buffer, so that it is easy
* for later writing large spice netlist using this as building block
xmux_out_driver vsp vbp vsn vbn out lut_out INV

xc0 vsp vbp vsn vbn wd bit0 nbit0 C_DATA0
xc1 vsp vbp vsn vbn wd bit1 nbit1 C_DATA1
xc2 vsp vbp vsn vbn wd bit2 nbit2 C_DATA0
xc3 vsp vbp vsn vbn wd bit3 nbit3 C_DATA1
xc4 vsp vbp vsn vbn wd bit4 nbit4 C_DATA0
xc5 vsp vbp vsn vbn wd bit5 nbit5 C_DATA1
xc6 vsp vbp vsn vbn wd bit6 nbit6 C_DATA0
xc7 vsp vbp vsn vbn wd bit7 nbit7 C_DATA1
xc8 vsp vbp vsn vbn wd bit8 nbit8 C_DATA0
xc9 vsp vbp vsn vbn wd bit9 nbit9 C_DATA1
xc10 vsp vbp vsn vbn wd bit10 nbit10 C_DATA0
xc11 vsp vbp vsn vbn wd bit11 nbit11 C_DATA1
xc12 vsp vbp vsn vbn wd bit12 nbit12 C_DATA0
xc13 vsp vbp vsn vbn wd bit13 nbit13 C_DATA1
xc14 vsp vbp vsn vbn wd bit14 nbit14 C_DATA0
xc15 vsp vbp vsn vbn wd bit15 nbit15 C_DATA1

* mux input inverters 
xi0 vsp vbp vsn vbn bit0 i0 INV2x
xi1 vsp vbp vsn vbn bit1 i1 INV2x
xi2 vsp vbp vsn vbn bit2 i2 INV2x
xi3 vsp vbp vsn vbn bit3 i3 INV2x
xi4 vsp vbp vsn vbn bit4 i4 INV2x
xi5 vsp vbp vsn vbn bit5 i5 INV2x
xi6 vsp vbp vsn vbn bit6 i6 INV2x
xi7 vsp vbp vsn vbn bit7 i7 INV2x
xi8 vsp vbp vsn vbn bit8 i8 INV2x
xi9 vsp vbp vsn vbn bit9 i9 INV2x
xi10 vsp vbp vsn vbn bit10 i10 INV2x
xi11 vsp vbp vsn vbn bit11 i11 INV2x
xi12 vsp vbp vsn vbn bit12 i12 INV2x
xi13 vsp vbp vsn vbn bit13 i13 INV2x
xi14 vsp vbp vsn vbn bit14 i14 INV2x
xi15 vsp vbp vsn vbn bit15 i15 INV2x

v_wd wd 0 v_supply_high

.ends lut4
* -----------------------------------------------------------
