* MUXes (pass transistor implementation)
*scalable lamda design rule

* Fei LI
* 07/17/02

*NOTE: pass-transsitor's bulk is always grounded (connected to node 0)
*      But we offer separate power/ground port for the buffer

* (1) MUX2_1 : without built-in input buffer for control lines
* (2) MUX2_1_buf: with buil-in input buffer for control lines
* (7) MUX16_1 : 16-1 mux without built-in input buffer for control lines
* (8) MUX16_1_buf: 16-mux with buil-in input buffer for control lines
* (9) MUX32_1 : 32-1 
* (10)MUX32_1_buf: 32-1 w/ buf
* (11)MUX64_1:     64-1
* (12)MUX64_1_buf: 64-1 w/ buf
* (13)MUX128_1:    128-1 w/ buf
* (14)MUX128_1_buf: 128-1 w/ buf

* (1) MUX2_1
* parameters
* =================
* lmda: design rule parameters (set in the file parameters.sp)
* v_supply: supply votage (set in the file parameters.sp)

* ports of the subckt and their functions
* =======================================
*     s0_b s0
*       |  |
*       v  |
* i0 ->    |
*          |  out->
* i1 ->	   v	

.subckt MUX2_1 i0 i1 s0 s0_b out
xn0 i0 out s0_b 0 NMOS_PASS
xn1 i1 out s0   0 NMOS_PASS
.ends MUX2_1

* (2) MUX2_1_buf
* ports of the subckt and their functions
* =======================================
*       s0       vsp vsn
* i0 ->
*         out->
* i1 ->
.subckt MUX2_1_buf vsp vbp vsn vbn i0 i1 s0 out
xg1 vsp vbp vsn vbn s0 s0_intb INV
xg2 vsp vbp vsn vbn s0_intb s0_buf INV2x
xg3 vsp vbp vsn vbn s0 s0_bar INV2x
xn0 i0 out s0_bar 0 NMOS_PASS
xn1 i1 out s0_buf 0 NMOS_PASS
.ends MUX2_1_buf

* (3) MUX4_1
* ports of the subckt and their functions
* =======================================
*       (lev0)      (lev1)
*      s0 s0_b     s1 s1_b
* i0
* i1						out->
* i2
* i3
.subckt MUX4_1 i0 i1 i2 i3 s0 s0_b s1 s1_b out
xlev00 i0 i1 s0 s0_b lev00_out MUX2_1
xlev01 i2 i3 s0 s0_b lev01_out MUX2_1

xlev10 lev00_out lev01_out s1 s1_b out MUX2_1
.ends MUX4_1

* (4) MUX4_1_buf
* ports of the subckt and their functions
* =======================================
*       (lev0)      (lev1)
*      s0 s0_b     s1 s1_b
* i0
* i1                        out->
* i2
* i3
.subckt MUX4_1_buf vsp vbp vsn vbn i0 i1 i2 i3 s0 s1 out
xg01 vsp vbp vsn vbn s0 s0_intb INV
xg02 vsp vbp vsn vbn s0_intb s0_buf INV2x
xg03 vsp vbp vsn vbn s0 s0_bar INV2x
xg11 vsp vbp vsn vbn s1 s1_intb INV
xg12 vsp vbp vsn vbn s1_intb s1_buf INV2x
xg13 vsp vbp vsn vbn s1 s1_bar INV2x

xlev i0 i1 i2 i3 s0_buf s0_bar s1_buf s1_bar out MUX4_1

.ends MUX4_1_buf


* (5) MUX8_1
.subckt MUX8_1 i0 i1 i2 i3 i4 i5 i6 i7 s0 s0_b s1 s1_b s2 s2_b out
xlev00 i0 i1 s0 s0_b lev00_out MUX2_1
xlev01 i2 i3 s0 s0_b lev01_out MUX2_1
xlev02 i4 i5 s0 s0_b lev02_out MUX2_1
xlev03 i6 i7 s0 s0_b lev03_out MUX2_1

xlev   lev00_out lev01_out lev02_out lev03_out s1 s1_b s2 s2_b out MUX4_1
.ends MUX8_1

* (6) MUX8_1_buf
.subckt MUX8_1_buf vsp vbp vsn vbn i0 i1 i2 i3 i4 i5 i6 i7 s0 s1 s2 out
xg01 vsp vbp vsn vbn s0 s0_intb INV
xg02 vsp vbp vsn vbn s0_intb s0_buf INV2x
xg03 vsp vbp vsn vbn s0 s0_bar INV2x
xg11 vsp vbp vsn vbn s1 s1_intb INV
xg12 vsp vbp vsn vbn s1_intb s1_buf INV2x
xg13 vsp vbp vsn vbn s1 s1_bar INV2x
xg21 vsp vbp vsn vbn s2 s2_intb INV
xg22 vsp vbp vsn vbn s2_intb s2_buf INV2x
xg23 vsp vbp vsn vbn s2 s2_bar INV2x

xlev i0 i1 i2 i3 i4 i5 i6 i7 s0_buf s0_bar s1_buf s1_bar s2_buf s2_bar out 
+ MUX8_1
.ends MUX8_1_buf

* (7) MUX16_1
.subckt MUX16_1 i0 i1 i2 i3 i4 i5 i6 i7 i8 i9 i10 i11 i12 i13 i14 i15
+               s0 s0_b s1 s1_b s2 s2_b s3 s3_b out
xlev00 i0 i1 s0 s0_b lev00_out MUX2_1
xlev01 i2 i3 s0 s0_b lev01_out MUX2_1
xlev02 i4 i5 s0 s0_b lev02_out MUX2_1
xlev03 i6 i7 s0 s0_b lev03_out MUX2_1
xlev04 i8 i9 s0 s0_b lev04_out MUX2_1
xlev05 i10 i11 s0 s0_b lev05_out MUX2_1
xlev06 i12 i13 s0 s0_b lev06_out MUX2_1
xlev07 i14 i15 s0 s0_b lev07_out MUX2_1

xlev lev00_out lev01_out lev02_out lev03_out lev04_out lev05_out
+    lev06_out lev07_out s1 s1_b s2 s2_b s3 s3_b out MUX8_1
.ends MUX16_1

* (8) MUX16_1_buf
.subckt MUX16_1_buf vsp vbp vsn vbn 
+                   i0 i1 i2 i3 i4 i5 i6 i7 i8 i9 i10 i11 i12 i13 i14 i15
+                   s0 s1 s2 s3 out
xg01 vsp vbp vsn vbn s0 s0_intb INV
xg02 vsp vbp vsn vbn s0_intb s0_buf INV2x
xg03 vsp vbp vsn vbn s0 s0_bar INV2x
xg11 vsp vbp vsn vbn s1 s1_intb INV
xg12 vsp vbp vsn vbn s1_intb s1_buf INV2x
xg13 vsp vbp vsn vbn s1 s1_bar INV2x
xg21 vsp vbp vsn vbn s2 s2_intb INV
xg22 vsp vbp vsn vbn s2_intb s2_buf INV2x
xg23 vsp vbp vsn vbn s2 s2_bar INV2x
xg31 vsp vbp vsn vbn s3 s3_intb INV
xg32 vsp vbp vsn vbn s3_intb s3_buf INV2x
xg33 vsp vbp vsn vbn s3 s3_bar INV2x

xlev i0 i1 i2 i3 i4 i5 i6 i7 i8 i9 i10 i11 i12 i13 i14 i15
+    s0_buf s0_bar s1_buf s1_bar s2_buf s2_bar s3_buf s3_bar out MUX16_1

.ends MUX16_1_buf


* (9) MUX32_1
.subckt MUX32_1 i0 i1 i2 i3 i4 i5 i6 i7 i8 i9 i10 i11 i12 i13 i14 i15
+               i16 i17 i18 i19 i20 i21 i22 i23 i24 i25 i26 i27 i28 i29 i30 i31
+               s0 s0_b s1 s1_b s2 s2_b s3 s3_b s4 s4_b out
xlev00 i0 i1 s0 s0_b lev00_out MUX2_1
xlev01 i2 i3 s0 s0_b lev01_out MUX2_1
xlev02 i4 i5 s0 s0_b lev02_out MUX2_1
xlev03 i6 i7 s0 s0_b lev03_out MUX2_1
xlev04 i8 i9 s0 s0_b lev04_out MUX2_1
xlev05 i10 i11 s0 s0_b lev05_out MUX2_1
xlev06 i12 i13 s0 s0_b lev06_out MUX2_1
xlev07 i14 i15 s0 s0_b lev07_out MUX2_1
xlev08 i16 i17 s0 s0_b lev08_out MUX2_1
xlev09 i18 i19 s0 s0_b lev09_out MUX2_1
xlev10 i20 i21 s0 s0_b lev10_out MUX2_1
xlev11 i22 i23 s0 s0_b lev11_out MUX2_1
xlev12 i24 i25 s0 s0_b lev12_out MUX2_1
xlev13 i26 i27 s0 s0_b lev13_out MUX2_1
xlev14 i28 i29 s0 s0_b lev14_out MUX2_1
xlev15 i30 i31 s0 s0_b lev15_out MUX2_1

xlev lev00_out lev01_out lev02_out lev03_out lev04_out lev05_out
+    lev06_out lev07_out lev08_out lev09_out lev10_out lev11_out
+    lev12_out lev13_out lev14_out lev15_out
+    s1 s1_b s2 s2_b s3 s3_b s4 s4_b out MUX16_1
.ends MUX32_1


* (10) MUX32_1_buf
.subckt MUX32_1_buf vsp vbp vsn vbn 
+                   i0 i1 i2 i3 i4 i5 i6 i7 i8 i9 i10 i11 i12 i13 i14 i15
+              i16 i17 i18 i19 i20 i21 i22 i23 i24 i25 i26 i27 i28 i29 i30 i31
+                   s0 s1 s2 s3 s4 out
xg01 vsp vbp vsn vbn s0 s0_intb INV
xg02 vsp vbp vsn vbn s0_intb s0_buf INV2x
xg03 vsp vbp vsn vbn s0 s0_bar INV2x
xg11 vsp vbp vsn vbn s1 s1_intb INV
xg12 vsp vbp vsn vbn s1_intb s1_buf INV2x
xg13 vsp vbp vsn vbn s1 s1_bar INV2x
xg21 vsp vbp vsn vbn s2 s2_intb INV
xg22 vsp vbp vsn vbn s2_intb s2_buf INV2x
xg23 vsp vbp vsn vbn s2 s2_bar INV2x
xg31 vsp vbp vsn vbn s3 s3_intb INV
xg32 vsp vbp vsn vbn s3_intb s3_buf INV2x
xg33 vsp vbp vsn vbn s3 s3_bar INV2x
xg41 vsp vbp vsn vbn s4 s4_intb INV
xg42 vsp vbp vsn vbn s4_intb s4_buf INV2x
xg43 vsp vbp vsn vbn s4 s4_bar INV2x

xlev i0 i1 i2 i3 i4 i5 i6 i7 i8 i9 i10 i11 i12 i13 i14 i15
+    i16 i17 i18 i19 i20 i21 i22 i23 i24 i25 i26 i27 i28 i29 i30 i31
+    s0_buf s0_bar s1_buf s1_bar s2_buf s2_bar s3_buf s3_bar s4_buf s4_bar
+    out MUX32_1

.ends MUX32_1_buf


* (11) MUX64_1
.subckt MUX64_1 i0 i1 i2 i3 i4 i5 i6 i7 i8 i9 i10 i11 i12 i13 i14 i15
+               i16 i17 i18 i19 i20 i21 i22 i23 i24 i25 i26 i27 i28 i29 i30 i31
+               i32 i33 i34 i35 i36 i37 i38 i39 i40 i41 i42 i43 i44 i45 i46 i47
+               i48 i49 i50 i51 i52 i53 i54 i55 i56 i57 i58 i59 i60 i61 i62 i63
+               s0 s0_b s1 s1_b s2 s2_b s3 s3_b s4 s4_b s5 s5_b out
xlev00 i0 i1 s0 s0_b lev00_out MUX2_1
xlev01 i2 i3 s0 s0_b lev01_out MUX2_1
xlev02 i4 i5 s0 s0_b lev02_out MUX2_1
xlev03 i6 i7 s0 s0_b lev03_out MUX2_1
xlev04 i8 i9 s0 s0_b lev04_out MUX2_1
xlev05 i10 i11 s0 s0_b lev05_out MUX2_1
xlev06 i12 i13 s0 s0_b lev06_out MUX2_1
xlev07 i14 i15 s0 s0_b lev07_out MUX2_1
xlev08 i16 i17 s0 s0_b lev08_out MUX2_1
xlev09 i18 i19 s0 s0_b lev09_out MUX2_1
xlev10 i20 i21 s0 s0_b lev10_out MUX2_1
xlev11 i22 i23 s0 s0_b lev11_out MUX2_1
xlev12 i24 i25 s0 s0_b lev12_out MUX2_1
xlev13 i26 i27 s0 s0_b lev13_out MUX2_1
xlev14 i28 i29 s0 s0_b lev14_out MUX2_1
xlev15 i30 i31 s0 s0_b lev15_out MUX2_1
xlev16 i32 i33 s0 s0_b lev16_out MUX2_1
xlev17 i34 i35 s0 s0_b lev17_out MUX2_1
xlev18 i36 i37 s0 s0_b lev18_out MUX2_1
xlev19 i38 i39 s0 s0_b lev19_out MUX2_1
xlev20 i40 i41 s0 s0_b lev20_out MUX2_1
xlev21 i42 i43 s0 s0_b lev21_out MUX2_1
xlev22 i44 i45 s0 s0_b lev22_out MUX2_1
xlev23 i46 i47 s0 s0_b lev23_out MUX2_1
xlev24 i48 i49 s0 s0_b lev24_out MUX2_1
xlev25 i50 i51 s0 s0_b lev25_out MUX2_1
xlev26 i52 i53 s0 s0_b lev26_out MUX2_1
xlev27 i54 i55 s0 s0_b lev27_out MUX2_1
xlev28 i56 i57 s0 s0_b lev28_out MUX2_1
xlev29 i58 i59 s0 s0_b lev29_out MUX2_1
xlev30 i60 i61 s0 s0_b lev30_out MUX2_1
xlev31 i62 i63 s0 s0_b lev31_out MUX2_1

xlev lev00_out lev01_out lev02_out lev03_out lev04_out lev05_out
+    lev06_out lev07_out lev08_out lev09_out lev10_out lev11_out
+    lev12_out lev13_out lev14_out lev15_out lev16_out lev17_out
+    lev18_out lev19_out lev20_out lev21_out lev22_out lev23_out
+    lev24_out lev25_out lev26_out lev27_out lev28_out lev29_out
+    lev30_out lev31_out
+    s1 s1_b s2 s2_b s3 s3_b s4 s4_b s5 s5_b out MUX32_1
.ends MUX64_1


* (12) MUX64_1_buf
.subckt MUX64_1_buf vsp vbp vsn vbn 
+                   i0 i1 i2 i3 i4 i5 i6 i7 i8 i9 i10 i11 i12 i13 i14 i15
+              i16 i17 i18 i19 i20 i21 i22 i23 i24 i25 i26 i27 i28 i29 i30 i31
+              i32 i33 i34 i35 i36 i37 i38 i39 i40 i41 i42 i43 i44 i45 i46 i47
+              i48 i49 i50 i51 i52 i53 i54 i55 i56 i57 i58 i59 i60 i61 i62 i63
+                   s0 s1 s2 s3 s4 s5 out
xg01 vsp vbp vsn vbn s0 s0_intb INV
xg02 vsp vbp vsn vbn s0_intb s0_buf INV2x
xg03 vsp vbp vsn vbn s0 s0_bar INV2x
xg11 vsp vbp vsn vbn s1 s1_intb INV
xg12 vsp vbp vsn vbn s1_intb s1_buf INV2x
xg13 vsp vbp vsn vbn s1 s1_bar INV2x
xg21 vsp vbp vsn vbn s2 s2_intb INV
xg22 vsp vbp vsn vbn s2_intb s2_buf INV2x
xg23 vsp vbp vsn vbn s2 s2_bar INV2x
xg31 vsp vbp vsn vbn s3 s3_intb INV
xg32 vsp vbp vsn vbn s3_intb s3_buf INV2x
xg33 vsp vbp vsn vbn s3 s3_bar INV2x
xg41 vsp vbp vsn vbn s4 s4_intb INV
xg42 vsp vbp vsn vbn s4_intb s4_buf INV2x
xg43 vsp vbp vsn vbn s4 s4_bar INV2x
xg51 vsp vbp vsn vbn s5 s5_intb INV
xg52 vsp vbp vsn vbn s5_intb s5_buf INV2x
xg53 vsp vbp vsn vbn s5 s5_bar INV2x

xlev i0 i1 i2 i3 i4 i5 i6 i7 i8 i9 i10 i11 i12 i13 i14 i15
+    i16 i17 i18 i19 i20 i21 i22 i23 i24 i25 i26 i27 i28 i29 i30 i31
+    i32 i33 i34 i35 i36 i37 i38 i39 i40 i41 i42 i43 i44 i45 i46 i47
+    i48 i49 i50 i51 i52 i53 i54 i55 i56 i57 i58 i59 i60 i61 i62 i63
+    s0_buf s0_bar s1_buf s1_bar s2_buf s2_bar s3_buf s3_bar s4_buf s4_bar
+    s5_buf s5_bar
+    out MUX64_1

.ends MUX64_1_buf



* (13) MUX128_1
.subckt MUX128_1 i0 i1 i2 i3 i4 i5 i6 i7 i8 i9 i10 i11 i12 i13 i14 i15
+               i16 i17 i18 i19 i20 i21 i22 i23 i24 i25 i26 i27 i28 i29 i30 i31
+               i32 i33 i34 i35 i36 i37 i38 i39 i40 i41 i42 i43 i44 i45 i46 i47
+               i48 i49 i50 i51 i52 i53 i54 i55 i56 i57 i58 i59 i60 i61 i62 i63
+               i64 i65 i66 i67 i68 i69 i70 i71 i72 i73 i74 i75 i76 i77 i78 i79
+               i80 i81 i82 i83 i84 i85 i86 i87 i88 i89 i90 i91 i92 i93 i94 i95
+               i96 i97 i98 i99 i100 i101 i102 i103 i104 i105 i106 i107 i108
+               i109 i110 i111 i112 i113 i114 i115 i116 i117 i118 i119 i120
+               i121 i122 i123 i124 i125 i126 i127
+               s0 s0_b s1 s1_b s2 s2_b s3 s3_b s4 s4_b s5 s5_b s6 s6_b out
xlev00 i0 i1 s0 s0_b lev00_out MUX2_1
xlev01 i2 i3 s0 s0_b lev01_out MUX2_1
xlev02 i4 i5 s0 s0_b lev02_out MUX2_1
xlev03 i6 i7 s0 s0_b lev03_out MUX2_1
xlev04 i8 i9 s0 s0_b lev04_out MUX2_1
xlev05 i10 i11 s0 s0_b lev05_out MUX2_1
xlev06 i12 i13 s0 s0_b lev06_out MUX2_1
xlev07 i14 i15 s0 s0_b lev07_out MUX2_1
xlev08 i16 i17 s0 s0_b lev08_out MUX2_1
xlev09 i18 i19 s0 s0_b lev09_out MUX2_1
xlev10 i20 i21 s0 s0_b lev10_out MUX2_1
xlev11 i22 i23 s0 s0_b lev11_out MUX2_1
xlev12 i24 i25 s0 s0_b lev12_out MUX2_1
xlev13 i26 i27 s0 s0_b lev13_out MUX2_1
xlev14 i28 i29 s0 s0_b lev14_out MUX2_1
xlev15 i30 i31 s0 s0_b lev15_out MUX2_1
xlev16 i32 i33 s0 s0_b lev16_out MUX2_1
xlev17 i34 i35 s0 s0_b lev17_out MUX2_1
xlev18 i36 i37 s0 s0_b lev18_out MUX2_1
xlev19 i38 i39 s0 s0_b lev19_out MUX2_1
xlev20 i40 i41 s0 s0_b lev20_out MUX2_1
xlev21 i42 i43 s0 s0_b lev21_out MUX2_1
xlev22 i44 i45 s0 s0_b lev22_out MUX2_1
xlev23 i46 i47 s0 s0_b lev23_out MUX2_1
xlev24 i48 i49 s0 s0_b lev24_out MUX2_1
xlev25 i50 i51 s0 s0_b lev25_out MUX2_1
xlev26 i52 i53 s0 s0_b lev26_out MUX2_1
xlev27 i54 i55 s0 s0_b lev27_out MUX2_1
xlev28 i56 i57 s0 s0_b lev28_out MUX2_1
xlev29 i58 i59 s0 s0_b lev29_out MUX2_1
xlev30 i60 i61 s0 s0_b lev30_out MUX2_1
xlev31 i62 i63 s0 s0_b lev31_out MUX2_1
xlev32 i64 i65 s0 s0_b lev32_out MUX2_1
xlev33 i66 i67 s0 s0_b lev33_out MUX2_1
xlev34 i68 i69 s0 s0_b lev34_out MUX2_1
xlev35 i70 i71 s0 s0_b lev35_out MUX2_1
xlev36 i72 i73 s0 s0_b lev36_out MUX2_1
xlev37 i74 i75 s0 s0_b lev37_out MUX2_1
xlev38 i76 i77 s0 s0_b lev38_out MUX2_1
xlev39 i78 i79 s0 s0_b lev39_out MUX2_1
xlev40 i80 i81 s0 s0_b lev40_out MUX2_1
xlev41 i82 i83 s0 s0_b lev41_out MUX2_1
xlev42 i84 i85 s0 s0_b lev42_out MUX2_1
xlev43 i86 i87 s0 s0_b lev43_out MUX2_1
xlev44 i88 i89 s0 s0_b lev44_out MUX2_1
xlev45 i90 i91 s0 s0_b lev45_out MUX2_1
xlev46 i92 i93 s0 s0_b lev46_out MUX2_1
xlev47 i94 i95 s0 s0_b lev47_out MUX2_1
xlev48 i96 i97 s0 s0_b lev48_out MUX2_1
xlev49 i98 i99 s0 s0_b lev49_out MUX2_1
xlev50 i100 i101 s0 s0_b lev50_out MUX2_1
xlev51 i102 i103 s0 s0_b lev51_out MUX2_1
xlev52 i104 i105 s0 s0_b lev52_out MUX2_1
xlev53 i106 i107 s0 s0_b lev53_out MUX2_1
xlev54 i108 i109 s0 s0_b lev54_out MUX2_1
xlev55 i110 i111 s0 s0_b lev55_out MUX2_1
xlev56 i112 i113 s0 s0_b lev56_out MUX2_1
xlev57 i114 i115 s0 s0_b lev57_out MUX2_1
xlev58 i116 i117 s0 s0_b lev58_out MUX2_1
xlev59 i118 i119 s0 s0_b lev59_out MUX2_1
xlev60 i120 i121 s0 s0_b lev60_out MUX2_1
xlev61 i122 i123 s0 s0_b lev61_out MUX2_1
xlev62 i124 i125 s0 s0_b lev62_out MUX2_1
xlev63 i126 i127 s0 s0_b lev63_out MUX2_1

xlev lev00_out lev01_out lev02_out lev03_out lev04_out lev05_out
+    lev06_out lev07_out lev08_out lev09_out lev10_out lev11_out
+    lev12_out lev13_out lev14_out lev15_out lev16_out lev17_out
+    lev18_out lev19_out lev20_out lev21_out lev22_out lev23_out
+    lev24_out lev25_out lev26_out lev27_out lev28_out lev29_out
+    lev30_out lev31_out lev32_out lev33_out lev34_out lev35_out
+    lev36_out lev37_out lev38_out lev39_out lev40_out lev41_out
+    lev42_out lev43_out lev44_out lev45_out lev46_out lev47_out
+    lev48_out lev49_out lev50_out lev51_out lev52_out lev53_out
+    lev54_out lev55_out lev56_out lev57_out lev58_out lev59_out
+    lev60_out lev61_out lev62_out lev63_out
+    s1 s1_b s2 s2_b s3 s3_b s4 s4_b s5 s5_b s6 s6_b out MUX64_1
.ends MUX128_1


* (14) MUX128_1_buf
.subckt MUX128_1_buf vsp vbp vsn vbn 
+                   i0 i1 i2 i3 i4 i5 i6 i7 i8 i9 i10 i11 i12 i13 i14 i15
+              i16 i17 i18 i19 i20 i21 i22 i23 i24 i25 i26 i27 i28 i29 i30 i31
+              i32 i33 i34 i35 i36 i37 i38 i39 i40 i41 i42 i43 i44 i45 i46 i47
+              i48 i49 i50 i51 i52 i53 i54 i55 i56 i57 i58 i59 i60 i61 i62 i63
+               i64 i65 i66 i67 i68 i69 i70 i71 i72 i73 i74 i75 i76 i77 i78 i79
+               i80 i81 i82 i83 i84 i85 i86 i87 i88 i89 i90 i91 i92 i93 i94 i95
+               i96 i97 i98 i99 i100 i101 i102 i103 i104 i105 i106 i107 i108
+               i109 i110 i111 i112 i113 i114 i115 i116 i117 i118 i119 i120
+               i121 i122 i123 i124 i125 i126 i127
+                   s0 s1 s2 s3 s4 s5 s6 out

xg01 vsp vbp vsn vbn s0 s0_intb INV
xg02 vsp vbp vsn vbn s0_intb s0_buf INV2x
xg03 vsp vbp vsn vbn s0 s0_bar INV2x
xg11 vsp vbp vsn vbn s1 s1_intb INV
xg12 vsp vbp vsn vbn s1_intb s1_buf INV2x
xg13 vsp vbp vsn vbn s1 s1_bar INV2x
xg21 vsp vbp vsn vbn s2 s2_intb INV
xg22 vsp vbp vsn vbn s2_intb s2_buf INV2x
xg23 vsp vbp vsn vbn s2 s2_bar INV2x
xg31 vsp vbp vsn vbn s3 s3_intb INV
xg32 vsp vbp vsn vbn s3_intb s3_buf INV2x
xg33 vsp vbp vsn vbn s3 s3_bar INV2x
xg41 vsp vbp vsn vbn s4 s4_intb INV
xg42 vsp vbp vsn vbn s4_intb s4_buf INV2x
xg43 vsp vbp vsn vbn s4 s4_bar INV2x
xg51 vsp vbp vsn vbn s5 s5_intb INV
xg52 vsp vbp vsn vbn s5_intb s5_buf INV2x
xg53 vsp vbp vsn vbn s5 s5_bar INV2x
xg61 vsp vbp vsn vbn s6 s6_intb INV
xg62 vsp vbp vsn vbn s6_intb s6_buf INV2x
xg63 vsp vbp vsn vbn s6 s6_bar INV2x

xlev i0 i1 i2 i3 i4 i5 i6 i7 i8 i9 i10 i11 i12 i13 i14 i15
+    i16 i17 i18 i19 i20 i21 i22 i23 i24 i25 i26 i27 i28 i29 i30 i31
+    i32 i33 i34 i35 i36 i37 i38 i39 i40 i41 i42 i43 i44 i45 i46 i47
+    i48 i49 i50 i51 i52 i53 i54 i55 i56 i57 i58 i59 i60 i61 i62 i63
+    i64 i65 i66 i67 i68 i69 i70 i71 i72 i73 i74 i75 i76 i77 i78 i79
+    i80 i81 i82 i83 i84 i85 i86 i87 i88 i89 i90 i91 i92 i93 i94 i95
+    i96 i97 i98 i99 i100 i101 i102 i103 i104 i105 i106 i107 i108
+    i109 i110 i111 i112 i113 i114 i115 i116 i117 i118 i119 i120
+    i121 i122 i123 i124 i125 i126 i127
+    s0_buf s0_bar s1_buf s1_bar s2_buf s2_bar s3_buf s3_bar s4_buf s4_bar
+    s5_buf s5_bar s6_buf s6_bar
+    out MUX128_1

.ends MUX128_1_buf


* ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
* vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv

* for low vdd = 1.0 ( Vt scaled with Vdd)

* (1) MUX2_1_VDDL10
* parameters
* =================
* lmda: design rule parameters (set in the file parameters.sp)
* v_supply: supply votage (set in the file parameters.sp)

* ports of the subckt and their functions
* =======================================
*     s0_b s0
*       |  |
*       v  |
* i0 ->    |
*          |  out->
* i1 ->	   v	

.subckt MUX2_1_VDDL10 i0 i1 s0 s0_b out
xn0 i0 out s0_b 0 NMOS_PASS_VDDL10
xn1 i1 out s0   0 NMOS_PASS_VDDL10
.ends MUX2_1_VDDL10

* (2) MUX2_1_buf_VDDL10
* ports of the subckt and their functions
* =======================================
*       s0       vsp vsn
* i0 ->
*         out->
* i1 ->
.subckt MUX2_1_buf_VDDL10 vsp vbp vsn vbn i0 i1 s0 out
xg1 vsp vbp vsn vbn s0 s0_intb INV_VDDL10
xg2 vsp vbp vsn vbn s0_intb s0_buf INV2x_VDDL10
xg3 vsp vbp vsn vbn s0 s0_bar INV2x_VDDL10
xn0 i0 out s0_bar 0 NMOS_PASS_VDDL10
xn1 i1 out s0_buf 0 NMOS_PASS_VDDL10
.ends MUX2_1_buf_VDDL10

* for low vdd = 0.9 ( Vt scaled with Vdd)

* (1) MUX2_1_VDDL09
* parameters
* =================
* lmda: design rule parameters (set in the file parameters.sp)
* v_supply: supply votage (set in the file parameters.sp)

* ports of the subckt and their functions
* =======================================
*     s0_b s0
*       |  |
*       v  |
* i0 ->    |
*          |  out->
* i1 ->	   v	

.subckt MUX2_1_VDDL09 i0 i1 s0 s0_b out
xn0 i0 out s0_b 0 NMOS_PASS_VDDL09
xn1 i1 out s0   0 NMOS_PASS_VDDL09
.ends MUX2_1_VDDL09

* (2) MUX2_1_buf_VDDL09
* ports of the subckt and their functions
* =======================================
*       s0       vsp vsn
* i0 ->
*         out->
* i1 ->
.subckt MUX2_1_buf_VDDL09 vsp vbp vsn vbn i0 i1 s0 out
xg1 vsp vbp vsn vbn s0 s0_intb INV_VDDL09
xg2 vsp vbp vsn vbn s0_intb s0_buf INV2x_VDDL09
xg3 vsp vbp vsn vbn s0 s0_bar INV2x_VDDL09
xn0 i0 out s0_bar 0 NMOS_PASS_VDDL09
xn1 i1 out s0_buf 0 NMOS_PASS_VDDL09
.ends MUX2_1_buf_VDDL09

* for low vdd = 0.8 ( Vt scaled with Vdd)

* (1) MUX2_1_VDDL08
* parameters
* =================
* lmda: design rule parameters (set in the file parameters.sp)
* v_supply: supply votage (set in the file parameters.sp)

* ports of the subckt and their functions
* =======================================
*     s0_b s0
*       |  |
*       v  |
* i0 ->    |
*          |  out->
* i1 ->	   v	

.subckt MUX2_1_VDDL08 i0 i1 s0 s0_b out
xn0 i0 out s0_b 0 NMOS_PASS_VDDL08
xn1 i1 out s0   0 NMOS_PASS_VDDL08
.ends MUX2_1_VDDL08

* (2) MUX2_1_buf_VDDL08
* ports of the subckt and their functions
* =======================================
*       s0       vsp vsn
* i0 ->
*         out->
* i1 ->
.subckt MUX2_1_buf_VDDL08 vsp vbp vsn vbn i0 i1 s0 out
xg1 vsp vbp vsn vbn s0 s0_intb INV_VDDL08
xg2 vsp vbp vsn vbn s0_intb s0_buf INV2x_VDDL08
xg3 vsp vbp vsn vbn s0 s0_bar INV2x_VDDL08
xn0 i0 out s0_bar 0 NMOS_PASS_VDDL08
xn1 i1 out s0_buf 0 NMOS_PASS_VDDL08
.ends MUX2_1_buf_VDDL08

* for low vdd = 0.7 ( Vt scaled with Vdd)

* (1) MUX2_1_VDDL07
* parameters
* =================
* lmda: design rule parameters (set in the file parameters.sp)
* v_supply: supply votage (set in the file parameters.sp)

* ports of the subckt and their functions
* =======================================
*     s0_b s0
*       |  |
*       v  |
* i0 ->    |
*          |  out->
* i1 ->	   v	

.subckt MUX2_1_VDDL07 i0 i1 s0 s0_b out
xn0 i0 out s0_b 0 NMOS_PASS_VDDL07
xn1 i1 out s0   0 NMOS_PASS_VDDL07
.ends MUX2_1_VDDL07

* (2) MUX2_1_buf_VDDL07
* ports of the subckt and their functions
* =======================================
*       s0       vsp vsn
* i0 ->
*         out->
* i1 ->
.subckt MUX2_1_buf_VDDL07 vsp vbp vsn vbn i0 i1 s0 out
xg1 vsp vbp vsn vbn s0 s0_intb INV_VDDL07
xg2 vsp vbp vsn vbn s0_intb s0_buf INV2x_VDDL07
xg3 vsp vbp vsn vbn s0 s0_bar INV2x_VDDL07
xn0 i0 out s0_bar 0 NMOS_PASS_VDDL07
xn1 i1 out s0_buf 0 NMOS_PASS_VDDL07
.ends MUX2_1_buf_VDDL07


* (3) MUX4_1_VDDL10
* ports of the subckt and their functions
* =======================================
*       (lev0)      (lev1)
*      s0 s0_b     s1 s1_b
* i0
* i1						out->
* i2
* i3
.subckt MUX4_1_VDDL10 i0 i1 i2 i3 s0 s0_b s1 s1_b out
xlev00 i0 i1 s0 s0_b lev00_out MUX2_1_VDDL10
xlev01 i2 i3 s0 s0_b lev01_out MUX2_1_VDDL10

xlev10 lev00_out lev01_out s1 s1_b out MUX2_1_VDDL10
.ends MUX4_1_VDDL10

* (4) MUX4_1_buf_VDDL10
* ports of the subckt and their functions
* =======================================
*       (lev0)      (lev1)
*      s0 s0_b     s1 s1_b
* i0
* i1                        out->
* i2
* i3
.subckt MUX4_1_buf_VDDL10 vsp vbp vsn vbn i0 i1 i2 i3 s0 s1 out
xg01 vsp vbp vsn vbn s0 s0_intb INV_VDDL10
xg02 vsp vbp vsn vbn s0_intb s0_buf INV2x_VDDL10
xg03 vsp vbp vsn vbn s0 s0_bar INV2x_VDDL10
xg11 vsp vbp vsn vbn s1 s1_intb INV_VDDL10
xg12 vsp vbp vsn vbn s1_intb s1_buf INV2x_VDDL10
xg13 vsp vbp vsn vbn s1 s1_bar INV2x_VDDL10

xlev i0 i1 i2 i3 s0_buf s0_bar s1_buf s1_bar out MUX4_1_VDDL10

.ends MUX4_1_buf_VDDL10


* (3) MUX4_1_VDDL09
* ports of the subckt and their functions
* =======================================
*       (lev0)      (lev1)
*      s0 s0_b     s1 s1_b
* i0
* i1						out->
* i2
* i3
.subckt MUX4_1_VDDL09 i0 i1 i2 i3 s0 s0_b s1 s1_b out
xlev00 i0 i1 s0 s0_b lev00_out MUX2_1_VDDL09
xlev01 i2 i3 s0 s0_b lev01_out MUX2_1_VDDL09

xlev10 lev00_out lev01_out s1 s1_b out MUX2_1_VDDL09
.ends MUX4_1_VDDL09

* (4) MUX4_1_buf_VDDL09
* ports of the subckt and their functions
* =======================================
*       (lev0)      (lev1)
*      s0 s0_b     s1 s1_b
* i0
* i1                        out->
* i2
* i3
.subckt MUX4_1_buf_VDDL09 vsp vbp vsn vbn i0 i1 i2 i3 s0 s1 out
xg01 vsp vbp vsn vbn s0 s0_intb INV_VDDL09
xg02 vsp vbp vsn vbn s0_intb s0_buf INV2x_VDDL09
xg03 vsp vbp vsn vbn s0 s0_bar INV2x_VDDL09
xg11 vsp vbp vsn vbn s1 s1_intb INV_VDDL09
xg12 vsp vbp vsn vbn s1_intb s1_buf INV2x_VDDL09
xg13 vsp vbp vsn vbn s1 s1_bar INV2x_VDDL09

xlev i0 i1 i2 i3 s0_buf s0_bar s1_buf s1_bar out MUX4_1_VDDL09

.ends MUX4_1_buf_VDDL09


* (3) MUX4_1_VDDL08
* ports of the subckt and their functions
* =======================================
*       (lev0)      (lev1)
*      s0 s0_b     s1 s1_b
* i0
* i1						out->
* i2
* i3
.subckt MUX4_1_VDDL08 i0 i1 i2 i3 s0 s0_b s1 s1_b out
xlev00 i0 i1 s0 s0_b lev00_out MUX2_1_VDDL08
xlev01 i2 i3 s0 s0_b lev01_out MUX2_1_VDDL08

xlev10 lev00_out lev01_out s1 s1_b out MUX2_1_VDDL08
.ends MUX4_1_VDDL08

* (4) MUX4_1_buf_VDDL08
* ports of the subckt and their functions
* =======================================
*       (lev0)      (lev1)
*      s0 s0_b     s1 s1_b
* i0
* i1                        out->
* i2
* i3
.subckt MUX4_1_buf_VDDL08 vsp vbp vsn vbn i0 i1 i2 i3 s0 s1 out
xg01 vsp vbp vsn vbn s0 s0_intb INV_VDDL08
xg02 vsp vbp vsn vbn s0_intb s0_buf INV2x_VDDL08
xg03 vsp vbp vsn vbn s0 s0_bar INV2x_VDDL08
xg11 vsp vbp vsn vbn s1 s1_intb INV_VDDL08
xg12 vsp vbp vsn vbn s1_intb s1_buf INV2x_VDDL08
xg13 vsp vbp vsn vbn s1 s1_bar INV2x_VDDL08

xlev i0 i1 i2 i3 s0_buf s0_bar s1_buf s1_bar out MUX4_1_VDDL08

.ends MUX4_1_buf_VDDL08


* (3) MUX4_1_VDDL07
* ports of the subckt and their functions
* =======================================
*       (lev0)      (lev1)
*      s0 s0_b     s1 s1_b
* i0
* i1						out->
* i2
* i3
.subckt MUX4_1_VDDL07 i0 i1 i2 i3 s0 s0_b s1 s1_b out
xlev00 i0 i1 s0 s0_b lev00_out MUX2_1_VDDL07
xlev01 i2 i3 s0 s0_b lev01_out MUX2_1_VDDL07

xlev10 lev00_out lev01_out s1 s1_b out MUX2_1_VDDL07
.ends MUX4_1_VDDL07

* (4) MUX4_1_buf_VDDL07
* ports of the subckt and their functions
* =======================================
*       (lev0)      (lev1)
*      s0 s0_b     s1 s1_b
* i0
* i1                        out->
* i2
* i3
.subckt MUX4_1_buf_VDDL07 vsp vbp vsn vbn i0 i1 i2 i3 s0 s1 out
xg01 vsp vbp vsn vbn s0 s0_intb INV_VDDL07
xg02 vsp vbp vsn vbn s0_intb s0_buf INV2x_VDDL07
xg03 vsp vbp vsn vbn s0 s0_bar INV2x_VDDL07
xg11 vsp vbp vsn vbn s1 s1_intb INV_VDDL07
xg12 vsp vbp vsn vbn s1_intb s1_buf INV2x_VDDL07
xg13 vsp vbp vsn vbn s1 s1_bar INV2x_VDDL07

xlev i0 i1 i2 i3 s0_buf s0_bar s1_buf s1_bar out MUX4_1_VDDL07

.ends MUX4_1_buf_VDDL07



* (5) MUX8_1_VDDL10
.subckt MUX8_1_VDDL10 i0 i1 i2 i3 i4 i5 i6 i7 s0 s0_b s1 s1_b s2 s2_b out
xlev00 i0 i1 s0 s0_b lev00_out MUX2_1_VDDL10
xlev01 i2 i3 s0 s0_b lev01_out MUX2_1_VDDL10
xlev02 i4 i5 s0 s0_b lev02_out MUX2_1_VDDL10
xlev03 i6 i7 s0 s0_b lev03_out MUX2_1_VDDL10

xlev   lev00_out lev01_out lev02_out lev03_out s1 s1_b s2 s2_b out MUX4_1_VDDL10
.ends MUX8_1_VDDL10

* (6) MUX8_1_buf_VDDL10
.subckt MUX8_1_buf_VDDL10 vsp vbp vsn vbn i0 i1 i2 i3 i4 i5 i6 i7 s0 s1 s2 out
xg01 vsp vbp vsn vbn s0 s0_intb INV_VDDL10
xg02 vsp vbp vsn vbn s0_intb s0_buf INV2x_VDDL10
xg03 vsp vbp vsn vbn s0 s0_bar INV2x_VDDL10
xg11 vsp vbp vsn vbn s1 s1_intb INV_VDDL10
xg12 vsp vbp vsn vbn s1_intb s1_buf INV2x_VDDL10
xg13 vsp vbp vsn vbn s1 s1_bar INV2x_VDDL10
xg21 vsp vbp vsn vbn s2 s2_intb INV_VDDL10
xg22 vsp vbp vsn vbn s2_intb s2_buf INV2x_VDDL10
xg23 vsp vbp vsn vbn s2 s2_bar INV2x_VDDL10

xlev i0 i1 i2 i3 i4 i5 i6 i7 s0_buf s0_bar s1_buf s1_bar s2_buf s2_bar out 
+ MUX8_1_VDDL10
.ends MUX8_1_buf_VDDL10


* (5) MUX8_1_VDDL09
.subckt MUX8_1_VDDL09 i0 i1 i2 i3 i4 i5 i6 i7 s0 s0_b s1 s1_b s2 s2_b out
xlev00 i0 i1 s0 s0_b lev00_out MUX2_1_VDDL09
xlev01 i2 i3 s0 s0_b lev01_out MUX2_1_VDDL09
xlev02 i4 i5 s0 s0_b lev02_out MUX2_1_VDDL09
xlev03 i6 i7 s0 s0_b lev03_out MUX2_1_VDDL09

xlev   lev00_out lev01_out lev02_out lev03_out s1 s1_b s2 s2_b out MUX4_1_VDDL09
.ends MUX8_1_VDDL09

* (6) MUX8_1_buf_VDDL09
.subckt MUX8_1_buf_VDDL09 vsp vbp vsn vbn i0 i1 i2 i3 i4 i5 i6 i7 s0 s1 s2 out
xg01 vsp vbp vsn vbn s0 s0_intb INV_VDDL09
xg02 vsp vbp vsn vbn s0_intb s0_buf INV2x_VDDL09
xg03 vsp vbp vsn vbn s0 s0_bar INV2x_VDDL09
xg11 vsp vbp vsn vbn s1 s1_intb INV_VDDL09
xg12 vsp vbp vsn vbn s1_intb s1_buf INV2x_VDDL09
xg13 vsp vbp vsn vbn s1 s1_bar INV2x_VDDL09
xg21 vsp vbp vsn vbn s2 s2_intb INV_VDDL09
xg22 vsp vbp vsn vbn s2_intb s2_buf INV2x_VDDL09
xg23 vsp vbp vsn vbn s2 s2_bar INV2x_VDDL09

xlev i0 i1 i2 i3 i4 i5 i6 i7 s0_buf s0_bar s1_buf s1_bar s2_buf s2_bar out 
+ MUX8_1_VDDL09
.ends MUX8_1_buf_VDDL09

* (5) MUX8_1_VDDL08
.subckt MUX8_1_VDDL08 i0 i1 i2 i3 i4 i5 i6 i7 s0 s0_b s1 s1_b s2 s2_b out
xlev00 i0 i1 s0 s0_b lev00_out MUX2_1_VDDL08
xlev01 i2 i3 s0 s0_b lev01_out MUX2_1_VDDL08
xlev02 i4 i5 s0 s0_b lev02_out MUX2_1_VDDL08
xlev03 i6 i7 s0 s0_b lev03_out MUX2_1_VDDL08

xlev   lev00_out lev01_out lev02_out lev03_out s1 s1_b s2 s2_b out MUX4_1_VDDL08
.ends MUX8_1_VDDL08

* (6) MUX8_1_buf_VDDL08
.subckt MUX8_1_buf_VDDL08 vsp vbp vsn vbn i0 i1 i2 i3 i4 i5 i6 i7 s0 s1 s2 out
xg01 vsp vbp vsn vbn s0 s0_intb INV_VDDL08
xg02 vsp vbp vsn vbn s0_intb s0_buf INV2x_VDDL08
xg03 vsp vbp vsn vbn s0 s0_bar INV2x_VDDL08
xg11 vsp vbp vsn vbn s1 s1_intb INV_VDDL08
xg12 vsp vbp vsn vbn s1_intb s1_buf INV2x_VDDL08
xg13 vsp vbp vsn vbn s1 s1_bar INV2x_VDDL08
xg21 vsp vbp vsn vbn s2 s2_intb INV_VDDL08
xg22 vsp vbp vsn vbn s2_intb s2_buf INV2x_VDDL08
xg23 vsp vbp vsn vbn s2 s2_bar INV2x_VDDL08

xlev i0 i1 i2 i3 i4 i5 i6 i7 s0_buf s0_bar s1_buf s1_bar s2_buf s2_bar out 
+ MUX8_1_VDDL08
.ends MUX8_1_buf_VDDL08


* (5) MUX8_1_VDDL07
.subckt MUX8_1_VDDL07 i0 i1 i2 i3 i4 i5 i6 i7 s0 s0_b s1 s1_b s2 s2_b out
xlev00 i0 i1 s0 s0_b lev00_out MUX2_1_VDDL07
xlev01 i2 i3 s0 s0_b lev01_out MUX2_1_VDDL07
xlev02 i4 i5 s0 s0_b lev02_out MUX2_1_VDDL07
xlev03 i6 i7 s0 s0_b lev03_out MUX2_1_VDDL07

xlev   lev00_out lev01_out lev02_out lev03_out s1 s1_b s2 s2_b out MUX4_1_VDDL07
.ends MUX8_1_VDDL07

* (6) MUX8_1_buf_VDDL07
.subckt MUX8_1_buf_VDDL07 vsp vbp vsn vbn i0 i1 i2 i3 i4 i5 i6 i7 s0 s1 s2 out
xg01 vsp vbp vsn vbn s0 s0_intb INV_VDDL07
xg02 vsp vbp vsn vbn s0_intb s0_buf INV2x_VDDL07
xg03 vsp vbp vsn vbn s0 s0_bar INV2x_VDDL07
xg11 vsp vbp vsn vbn s1 s1_intb INV_VDDL07
xg12 vsp vbp vsn vbn s1_intb s1_buf INV2x_VDDL07
xg13 vsp vbp vsn vbn s1 s1_bar INV2x_VDDL07
xg21 vsp vbp vsn vbn s2 s2_intb INV_VDDL07
xg22 vsp vbp vsn vbn s2_intb s2_buf INV2x_VDDL07
xg23 vsp vbp vsn vbn s2 s2_bar INV2x_VDDL07

xlev i0 i1 i2 i3 i4 i5 i6 i7 s0_buf s0_bar s1_buf s1_bar s2_buf s2_bar out 
+ MUX8_1_VDDL07
.ends MUX8_1_buf_VDDL07



* (7) MUX16_1_VDDL10
.subckt MUX16_1_VDDL10 i0 i1 i2 i3 i4 i5 i6 i7 i8 i9 i10 i11 i12 i13 i14 i15
+               s0 s0_b s1 s1_b s2 s2_b s3 s3_b out
xlev00 i0 i1 s0 s0_b lev00_out MUX2_1_VDDL10
xlev01 i2 i3 s0 s0_b lev01_out MUX2_1_VDDL10
xlev02 i4 i5 s0 s0_b lev02_out MUX2_1_VDDL10
xlev03 i6 i7 s0 s0_b lev03_out MUX2_1_VDDL10
xlev04 i8 i9 s0 s0_b lev04_out MUX2_1_VDDL10
xlev05 i10 i11 s0 s0_b lev05_out MUX2_1_VDDL10
xlev06 i12 i13 s0 s0_b lev06_out MUX2_1_VDDL10
xlev07 i14 i15 s0 s0_b lev07_out MUX2_1_VDDL10

xlev lev00_out lev01_out lev02_out lev03_out lev04_out lev05_out
+    lev06_out lev07_out s1 s1_b s2 s2_b s3 s3_b out MUX8_1_VDDL10
.ends MUX16_1_VDDL10

* (8) MUX16_1_buf_VDDL10
.subckt MUX16_1_buf_VDDL10 vsp vbp vsn vbn 
+                   i0 i1 i2 i3 i4 i5 i6 i7 i8 i9 i10 i11 i12 i13 i14 i15
+                   s0 s1 s2 s3 out
xg01 vsp vbp vsn vbn s0 s0_intb INV_VDDL10
xg02 vsp vbp vsn vbn s0_intb s0_buf INV2x_VDDL10
xg03 vsp vbp vsn vbn s0 s0_bar INV2x_VDDL10
xg11 vsp vbp vsn vbn s1 s1_intb INV_VDDL10
xg12 vsp vbp vsn vbn s1_intb s1_buf INV2x_VDDL10
xg13 vsp vbp vsn vbn s1 s1_bar INV2x_VDDL10
xg21 vsp vbp vsn vbn s2 s2_intb INV_VDDL10
xg22 vsp vbp vsn vbn s2_intb s2_buf INV2x_VDDL10
xg23 vsp vbp vsn vbn s2 s2_bar INV2x_VDDL10
xg31 vsp vbp vsn vbn s3 s3_intb INV_VDDL10
xg32 vsp vbp vsn vbn s3_intb s3_buf INV2x_VDDL10
xg33 vsp vbp vsn vbn s3 s3_bar INV2x_VDDL10

xlev i0 i1 i2 i3 i4 i5 i6 i7 i8 i9 i10 i11 i12 i13 i14 i15
+    s0_buf s0_bar s1_buf s1_bar s2_buf s2_bar s3_buf s3_bar out MUX16_1_VDDL10

.ends MUX16_1_buf_VDDL10


* (7) MUX16_1_VDDL09
.subckt MUX16_1_VDDL09 i0 i1 i2 i3 i4 i5 i6 i7 i8 i9 i10 i11 i12 i13 i14 i15
+               s0 s0_b s1 s1_b s2 s2_b s3 s3_b out
xlev00 i0 i1 s0 s0_b lev00_out MUX2_1_VDDL09
xlev01 i2 i3 s0 s0_b lev01_out MUX2_1_VDDL09
xlev02 i4 i5 s0 s0_b lev02_out MUX2_1_VDDL09
xlev03 i6 i7 s0 s0_b lev03_out MUX2_1_VDDL09
xlev04 i8 i9 s0 s0_b lev04_out MUX2_1_VDDL09
xlev05 i10 i11 s0 s0_b lev05_out MUX2_1_VDDL09
xlev06 i12 i13 s0 s0_b lev06_out MUX2_1_VDDL09
xlev07 i14 i15 s0 s0_b lev07_out MUX2_1_VDDL09

xlev lev00_out lev01_out lev02_out lev03_out lev04_out lev05_out
+    lev06_out lev07_out s1 s1_b s2 s2_b s3 s3_b out MUX8_1_VDDL09
.ends MUX16_1_VDDL09

* (8) MUX16_1_buf_VDDL09
.subckt MUX16_1_buf_VDDL09 vsp vbp vsn vbn 
+                   i0 i1 i2 i3 i4 i5 i6 i7 i8 i9 i10 i11 i12 i13 i14 i15
+                   s0 s1 s2 s3 out
xg01 vsp vbp vsn vbn s0 s0_intb INV_VDDL09
xg02 vsp vbp vsn vbn s0_intb s0_buf INV2x_VDDL09
xg03 vsp vbp vsn vbn s0 s0_bar INV2x_VDDL09
xg11 vsp vbp vsn vbn s1 s1_intb INV_VDDL09
xg12 vsp vbp vsn vbn s1_intb s1_buf INV2x_VDDL09
xg13 vsp vbp vsn vbn s1 s1_bar INV2x_VDDL09
xg21 vsp vbp vsn vbn s2 s2_intb INV_VDDL09
xg22 vsp vbp vsn vbn s2_intb s2_buf INV2x_VDDL09
xg23 vsp vbp vsn vbn s2 s2_bar INV2x_VDDL09
xg31 vsp vbp vsn vbn s3 s3_intb INV_VDDL09
xg32 vsp vbp vsn vbn s3_intb s3_buf INV2x_VDDL09
xg33 vsp vbp vsn vbn s3 s3_bar INV2x_VDDL09

xlev i0 i1 i2 i3 i4 i5 i6 i7 i8 i9 i10 i11 i12 i13 i14 i15
+    s0_buf s0_bar s1_buf s1_bar s2_buf s2_bar s3_buf s3_bar out MUX16_1_VDDL09

.ends MUX16_1_buf_VDDL09


* (7) MUX16_1_VDDL08
.subckt MUX16_1_VDDL08 i0 i1 i2 i3 i4 i5 i6 i7 i8 i9 i10 i11 i12 i13 i14 i15
+               s0 s0_b s1 s1_b s2 s2_b s3 s3_b out
xlev00 i0 i1 s0 s0_b lev00_out MUX2_1_VDDL08
xlev01 i2 i3 s0 s0_b lev01_out MUX2_1_VDDL08
xlev02 i4 i5 s0 s0_b lev02_out MUX2_1_VDDL08
xlev03 i6 i7 s0 s0_b lev03_out MUX2_1_VDDL08
xlev04 i8 i9 s0 s0_b lev04_out MUX2_1_VDDL08
xlev05 i10 i11 s0 s0_b lev05_out MUX2_1_VDDL08
xlev06 i12 i13 s0 s0_b lev06_out MUX2_1_VDDL08
xlev07 i14 i15 s0 s0_b lev07_out MUX2_1_VDDL08

xlev lev00_out lev01_out lev02_out lev03_out lev04_out lev05_out
+    lev06_out lev07_out s1 s1_b s2 s2_b s3 s3_b out MUX8_1_VDDL08
.ends MUX16_1_VDDL08

* (8) MUX16_1_buf_VDDL08
.subckt MUX16_1_buf_VDDL08 vsp vbp vsn vbn 
+                   i0 i1 i2 i3 i4 i5 i6 i7 i8 i9 i10 i11 i12 i13 i14 i15
+                   s0 s1 s2 s3 out
xg01 vsp vbp vsn vbn s0 s0_intb INV_VDDL08
xg02 vsp vbp vsn vbn s0_intb s0_buf INV2x_VDDL08
xg03 vsp vbp vsn vbn s0 s0_bar INV2x_VDDL08
xg11 vsp vbp vsn vbn s1 s1_intb INV_VDDL08
xg12 vsp vbp vsn vbn s1_intb s1_buf INV2x_VDDL08
xg13 vsp vbp vsn vbn s1 s1_bar INV2x_VDDL08
xg21 vsp vbp vsn vbn s2 s2_intb INV_VDDL08
xg22 vsp vbp vsn vbn s2_intb s2_buf INV2x_VDDL08
xg23 vsp vbp vsn vbn s2 s2_bar INV2x_VDDL08
xg31 vsp vbp vsn vbn s3 s3_intb INV_VDDL08
xg32 vsp vbp vsn vbn s3_intb s3_buf INV2x_VDDL08
xg33 vsp vbp vsn vbn s3 s3_bar INV2x_VDDL08

xlev i0 i1 i2 i3 i4 i5 i6 i7 i8 i9 i10 i11 i12 i13 i14 i15
+    s0_buf s0_bar s1_buf s1_bar s2_buf s2_bar s3_buf s3_bar out MUX16_1_VDDL08

.ends MUX16_1_buf_VDDL08


* (7) MUX16_1_VDDL07
.subckt MUX16_1_VDDL07 i0 i1 i2 i3 i4 i5 i6 i7 i8 i9 i10 i11 i12 i13 i14 i15
+               s0 s0_b s1 s1_b s2 s2_b s3 s3_b out
xlev00 i0 i1 s0 s0_b lev00_out MUX2_1_VDDL07
xlev01 i2 i3 s0 s0_b lev01_out MUX2_1_VDDL07
xlev02 i4 i5 s0 s0_b lev02_out MUX2_1_VDDL07
xlev03 i6 i7 s0 s0_b lev03_out MUX2_1_VDDL07
xlev04 i8 i9 s0 s0_b lev04_out MUX2_1_VDDL07
xlev05 i10 i11 s0 s0_b lev05_out MUX2_1_VDDL07
xlev06 i12 i13 s0 s0_b lev06_out MUX2_1_VDDL07
xlev07 i14 i15 s0 s0_b lev07_out MUX2_1_VDDL07

xlev lev00_out lev01_out lev02_out lev03_out lev04_out lev05_out
+    lev06_out lev07_out s1 s1_b s2 s2_b s3 s3_b out MUX8_1_VDDL07
.ends MUX16_1_VDDL07

* (8) MUX16_1_buf_VDDL07
.subckt MUX16_1_buf_VDDL07 vsp vbp vsn vbn 
+                   i0 i1 i2 i3 i4 i5 i6 i7 i8 i9 i10 i11 i12 i13 i14 i15
+                   s0 s1 s2 s3 out
xg01 vsp vbp vsn vbn s0 s0_intb INV_VDDL07
xg02 vsp vbp vsn vbn s0_intb s0_buf INV2x_VDDL07
xg03 vsp vbp vsn vbn s0 s0_bar INV2x_VDDL07
xg11 vsp vbp vsn vbn s1 s1_intb INV_VDDL07
xg12 vsp vbp vsn vbn s1_intb s1_buf INV2x_VDDL07
xg13 vsp vbp vsn vbn s1 s1_bar INV2x_VDDL07
xg21 vsp vbp vsn vbn s2 s2_intb INV_VDDL07
xg22 vsp vbp vsn vbn s2_intb s2_buf INV2x_VDDL07
xg23 vsp vbp vsn vbn s2 s2_bar INV2x_VDDL07
xg31 vsp vbp vsn vbn s3 s3_intb INV_VDDL07
xg32 vsp vbp vsn vbn s3_intb s3_buf INV2x_VDDL07
xg33 vsp vbp vsn vbn s3 s3_bar INV2x_VDDL07

xlev i0 i1 i2 i3 i4 i5 i6 i7 i8 i9 i10 i11 i12 i13 i14 i15
+    s0_buf s0_bar s1_buf s1_bar s2_buf s2_bar s3_buf s3_bar out MUX16_1_VDDL07

.ends MUX16_1_buf_VDDL07



* (9) MUX32_1_VDDL10
.subckt MUX32_1_VDDL10 i0 i1 i2 i3 i4 i5 i6 i7 i8 i9 i10 i11 i12 i13 i14 i15
+               i16 i17 i18 i19 i20 i21 i22 i23 i24 i25 i26 i27 i28 i29 i30 i31
+               s0 s0_b s1 s1_b s2 s2_b s3 s3_b s4 s4_b out
xlev00 i0 i1 s0 s0_b lev00_out MUX2_1_VDDL10
xlev01 i2 i3 s0 s0_b lev01_out MUX2_1_VDDL10
xlev02 i4 i5 s0 s0_b lev02_out MUX2_1_VDDL10
xlev03 i6 i7 s0 s0_b lev03_out MUX2_1_VDDL10
xlev04 i8 i9 s0 s0_b lev04_out MUX2_1_VDDL10
xlev05 i10 i11 s0 s0_b lev05_out MUX2_1_VDDL10
xlev06 i12 i13 s0 s0_b lev06_out MUX2_1_VDDL10
xlev07 i14 i15 s0 s0_b lev07_out MUX2_1_VDDL10
xlev08 i16 i17 s0 s0_b lev08_out MUX2_1_VDDL10
xlev09 i18 i19 s0 s0_b lev09_out MUX2_1_VDDL10
xlev10 i20 i21 s0 s0_b lev10_out MUX2_1_VDDL10
xlev11 i22 i23 s0 s0_b lev11_out MUX2_1_VDDL10
xlev12 i24 i25 s0 s0_b lev12_out MUX2_1_VDDL10
xlev13 i26 i27 s0 s0_b lev13_out MUX2_1_VDDL10
xlev14 i28 i29 s0 s0_b lev14_out MUX2_1_VDDL10
xlev15 i30 i31 s0 s0_b lev15_out MUX2_1_VDDL10

xlev lev00_out lev01_out lev02_out lev03_out lev04_out lev05_out
+    lev06_out lev07_out lev08_out lev09_out lev10_out lev11_out
+    lev12_out lev13_out lev14_out lev15_out
+    s1 s1_b s2 s2_b s3 s3_b s4 s4_b out MUX16_1_VDDL10
.ends MUX32_1_VDDL10


* (10) MUX32_1_buf_VDDL10
.subckt MUX32_1_buf_VDDL10 vsp vbp vsn vbn 
+                   i0 i1 i2 i3 i4 i5 i6 i7 i8 i9 i10 i11 i12 i13 i14 i15
+              i16 i17 i18 i19 i20 i21 i22 i23 i24 i25 i26 i27 i28 i29 i30 i31
+                   s0 s1 s2 s3 s4 out
xg01 vsp vbp vsn vbn s0 s0_intb INV_VDDL10
xg02 vsp vbp vsn vbn s0_intb s0_buf INV2x_VDDL10
xg03 vsp vbp vsn vbn s0 s0_bar INV2x_VDDL10
xg11 vsp vbp vsn vbn s1 s1_intb INV_VDDL10
xg12 vsp vbp vsn vbn s1_intb s1_buf INV2x_VDDL10
xg13 vsp vbp vsn vbn s1 s1_bar INV2x_VDDL10
xg21 vsp vbp vsn vbn s2 s2_intb INV_VDDL10
xg22 vsp vbp vsn vbn s2_intb s2_buf INV2x_VDDL10
xg23 vsp vbp vsn vbn s2 s2_bar INV2x_VDDL10
xg31 vsp vbp vsn vbn s3 s3_intb INV_VDDL10
xg32 vsp vbp vsn vbn s3_intb s3_buf INV2x_VDDL10
xg33 vsp vbp vsn vbn s3 s3_bar INV2x_VDDL10
xg41 vsp vbp vsn vbn s4 s4_intb INV_VDDL10
xg42 vsp vbp vsn vbn s4_intb s4_buf INV2x_VDDL10
xg43 vsp vbp vsn vbn s4 s4_bar INV2x_VDDL10

xlev i0 i1 i2 i3 i4 i5 i6 i7 i8 i9 i10 i11 i12 i13 i14 i15
+    i16 i17 i18 i19 i20 i21 i22 i23 i24 i25 i26 i27 i28 i29 i30 i31
+    s0_buf s0_bar s1_buf s1_bar s2_buf s2_bar s3_buf s3_bar s4_buf s4_bar
+    out MUX32_1_VDDL10

.ends MUX32_1_buf_VDDL10

* () MUX32_1_VDDL08
.subckt MUX32_1_VDDL08 i0 i1 i2 i3 i4 i5 i6 i7 i8 i9 i10 i11 i12 i13 i14 i15
+               i16 i17 i18 i19 i20 i21 i22 i23 i24 i25 i26 i27 i28 i29 i30 i31
+               s0 s0_b s1 s1_b s2 s2_b s3 s3_b s4 s4_b out
xlev00 i0 i1 s0 s0_b lev00_out MUX2_1_VDDL08
xlev01 i2 i3 s0 s0_b lev01_out MUX2_1_VDDL08
xlev02 i4 i5 s0 s0_b lev02_out MUX2_1_VDDL08
xlev03 i6 i7 s0 s0_b lev03_out MUX2_1_VDDL08
xlev04 i8 i9 s0 s0_b lev04_out MUX2_1_VDDL08
xlev05 i10 i11 s0 s0_b lev05_out MUX2_1_VDDL08
xlev06 i12 i13 s0 s0_b lev06_out MUX2_1_VDDL08
xlev07 i14 i15 s0 s0_b lev07_out MUX2_1_VDDL08
xlev08 i16 i17 s0 s0_b lev08_out MUX2_1_VDDL08
xlev09 i18 i19 s0 s0_b lev09_out MUX2_1_VDDL08
xlev10 i20 i21 s0 s0_b lev10_out MUX2_1_VDDL08
xlev11 i22 i23 s0 s0_b lev11_out MUX2_1_VDDL08
xlev12 i24 i25 s0 s0_b lev12_out MUX2_1_VDDL08
xlev13 i26 i27 s0 s0_b lev13_out MUX2_1_VDDL08
xlev14 i28 i29 s0 s0_b lev14_out MUX2_1_VDDL08
xlev15 i30 i31 s0 s0_b lev15_out MUX2_1_VDDL08

xlev lev00_out lev01_out lev02_out lev03_out lev04_out lev05_out
+    lev06_out lev07_out lev08_out lev09_out lev10_out lev11_out
+    lev12_out lev13_out lev14_out lev15_out
+    s1 s1_b s2 s2_b s3 s3_b s4 s4_b out MUX16_1_VDDL08
.ends MUX32_1_VDDL08


* () MUX32_1_buf_VDDL08
.subckt MUX32_1_buf_VDDL08 vsp vbp vsn vbn 
+                   i0 i1 i2 i3 i4 i5 i6 i7 i8 i9 i10 i11 i12 i13 i14 i15
+              i16 i17 i18 i19 i20 i21 i22 i23 i24 i25 i26 i27 i28 i29 i30 i31
+                   s0 s1 s2 s3 s4 out
xg01 vsp vbp vsn vbn s0 s0_intb INV_VDDL08
xg02 vsp vbp vsn vbn s0_intb s0_buf INV2x_VDDL08
xg03 vsp vbp vsn vbn s0 s0_bar INV2x_VDDL08
xg11 vsp vbp vsn vbn s1 s1_intb INV_VDDL08
xg12 vsp vbp vsn vbn s1_intb s1_buf INV2x_VDDL08
xg13 vsp vbp vsn vbn s1 s1_bar INV2x_VDDL08
xg21 vsp vbp vsn vbn s2 s2_intb INV_VDDL08
xg22 vsp vbp vsn vbn s2_intb s2_buf INV2x_VDDL08
xg23 vsp vbp vsn vbn s2 s2_bar INV2x_VDDL08
xg31 vsp vbp vsn vbn s3 s3_intb INV_VDDL08
xg32 vsp vbp vsn vbn s3_intb s3_buf INV2x_VDDL08
xg33 vsp vbp vsn vbn s3 s3_bar INV2x_VDDL08
xg41 vsp vbp vsn vbn s4 s4_intb INV_VDDL08
xg42 vsp vbp vsn vbn s4_intb s4_buf INV2x_VDDL08
xg43 vsp vbp vsn vbn s4 s4_bar INV2x_VDDL08

xlev i0 i1 i2 i3 i4 i5 i6 i7 i8 i9 i10 i11 i12 i13 i14 i15
+    i16 i17 i18 i19 i20 i21 i22 i23 i24 i25 i26 i27 i28 i29 i30 i31
+    s0_buf s0_bar s1_buf s1_bar s2_buf s2_bar s3_buf s3_bar s4_buf s4_bar
+    out MUX32_1_VDDL08

.ends MUX32_1_buf_VDDL08


* (11) MUX64_1_VDDL10
.subckt MUX64_1_VDDL10 i0 i1 i2 i3 i4 i5 i6 i7 i8 i9 i10 i11 i12 i13 i14 i15
+               i16 i17 i18 i19 i20 i21 i22 i23 i24 i25 i26 i27 i28 i29 i30 i31
+               i32 i33 i34 i35 i36 i37 i38 i39 i40 i41 i42 i43 i44 i45 i46 i47
+               i48 i49 i50 i51 i52 i53 i54 i55 i56 i57 i58 i59 i60 i61 i62 i63
+               s0 s0_b s1 s1_b s2 s2_b s3 s3_b s4 s4_b s5 s5_b out
xlev00 i0 i1 s0 s0_b lev00_out MUX2_1_VDDL10
xlev01 i2 i3 s0 s0_b lev01_out MUX2_1_VDDL10
xlev02 i4 i5 s0 s0_b lev02_out MUX2_1_VDDL10
xlev03 i6 i7 s0 s0_b lev03_out MUX2_1_VDDL10
xlev04 i8 i9 s0 s0_b lev04_out MUX2_1_VDDL10
xlev05 i10 i11 s0 s0_b lev05_out MUX2_1_VDDL10
xlev06 i12 i13 s0 s0_b lev06_out MUX2_1_VDDL10
xlev07 i14 i15 s0 s0_b lev07_out MUX2_1_VDDL10
xlev08 i16 i17 s0 s0_b lev08_out MUX2_1_VDDL10
xlev09 i18 i19 s0 s0_b lev09_out MUX2_1_VDDL10
xlev10 i20 i21 s0 s0_b lev10_out MUX2_1_VDDL10
xlev11 i22 i23 s0 s0_b lev11_out MUX2_1_VDDL10
xlev12 i24 i25 s0 s0_b lev12_out MUX2_1_VDDL10
xlev13 i26 i27 s0 s0_b lev13_out MUX2_1_VDDL10
xlev14 i28 i29 s0 s0_b lev14_out MUX2_1_VDDL10
xlev15 i30 i31 s0 s0_b lev15_out MUX2_1_VDDL10
xlev16 i32 i33 s0 s0_b lev16_out MUX2_1_VDDL10
xlev17 i34 i35 s0 s0_b lev17_out MUX2_1_VDDL10
xlev18 i36 i37 s0 s0_b lev18_out MUX2_1_VDDL10
xlev19 i38 i39 s0 s0_b lev19_out MUX2_1_VDDL10
xlev20 i40 i41 s0 s0_b lev20_out MUX2_1_VDDL10
xlev21 i42 i43 s0 s0_b lev21_out MUX2_1_VDDL10
xlev22 i44 i45 s0 s0_b lev22_out MUX2_1_VDDL10
xlev23 i46 i47 s0 s0_b lev23_out MUX2_1_VDDL10
xlev24 i48 i49 s0 s0_b lev24_out MUX2_1_VDDL10
xlev25 i50 i51 s0 s0_b lev25_out MUX2_1_VDDL10
xlev26 i52 i53 s0 s0_b lev26_out MUX2_1_VDDL10
xlev27 i54 i55 s0 s0_b lev27_out MUX2_1_VDDL10
xlev28 i56 i57 s0 s0_b lev28_out MUX2_1_VDDL10
xlev29 i58 i59 s0 s0_b lev29_out MUX2_1_VDDL10
xlev30 i60 i61 s0 s0_b lev30_out MUX2_1_VDDL10
xlev31 i62 i63 s0 s0_b lev31_out MUX2_1_VDDL10

xlev lev00_out lev01_out lev02_out lev03_out lev04_out lev05_out
+    lev06_out lev07_out lev08_out lev09_out lev10_out lev11_out
+    lev12_out lev13_out lev14_out lev15_out lev16_out lev17_out
+    lev18_out lev19_out lev20_out lev21_out lev22_out lev23_out
+    lev24_out lev25_out lev26_out lev27_out lev28_out lev29_out
+    lev30_out lev31_out
+    s1 s1_b s2 s2_b s3 s3_b s4 s4_b s5 s5_b out MUX32_1_VDDL10
.ends MUX64_1_VDDL10


* (12) MUX64_1_buf_VDDL10
.subckt MUX64_1_buf_VDDL10 vsp vbp vsn vbn 
+                   i0 i1 i2 i3 i4 i5 i6 i7 i8 i9 i10 i11 i12 i13 i14 i15
+              i16 i17 i18 i19 i20 i21 i22 i23 i24 i25 i26 i27 i28 i29 i30 i31
+              i32 i33 i34 i35 i36 i37 i38 i39 i40 i41 i42 i43 i44 i45 i46 i47
+              i48 i49 i50 i51 i52 i53 i54 i55 i56 i57 i58 i59 i60 i61 i62 i63
+                   s0 s1 s2 s3 s4 s5 out
xg01 vsp vbp vsn vbn s0 s0_intb INV_VDDL10
xg02 vsp vbp vsn vbn s0_intb s0_buf INV2x_VDDL10
xg03 vsp vbp vsn vbn s0 s0_bar INV2x_VDDL10
xg11 vsp vbp vsn vbn s1 s1_intb INV_VDDL10
xg12 vsp vbp vsn vbn s1_intb s1_buf INV2x_VDDL10
xg13 vsp vbp vsn vbn s1 s1_bar INV2x_VDDL10
xg21 vsp vbp vsn vbn s2 s2_intb INV_VDDL10
xg22 vsp vbp vsn vbn s2_intb s2_buf INV2x_VDDL10
xg23 vsp vbp vsn vbn s2 s2_bar INV2x_VDDL10
xg31 vsp vbp vsn vbn s3 s3_intb INV_VDDL10
xg32 vsp vbp vsn vbn s3_intb s3_buf INV2x_VDDL10
xg33 vsp vbp vsn vbn s3 s3_bar INV2x_VDDL10
xg41 vsp vbp vsn vbn s4 s4_intb INV_VDDL10
xg42 vsp vbp vsn vbn s4_intb s4_buf INV2x_VDDL10
xg43 vsp vbp vsn vbn s4 s4_bar INV2x_VDDL10
xg51 vsp vbp vsn vbn s5 s5_intb INV_VDDL10
xg52 vsp vbp vsn vbn s5_intb s5_buf INV2x_VDDL10
xg53 vsp vbp vsn vbn s5 s5_bar INV2x_VDDL10

xlev i0 i1 i2 i3 i4 i5 i6 i7 i8 i9 i10 i11 i12 i13 i14 i15
+    i16 i17 i18 i19 i20 i21 i22 i23 i24 i25 i26 i27 i28 i29 i30 i31
+    i32 i33 i34 i35 i36 i37 i38 i39 i40 i41 i42 i43 i44 i45 i46 i47
+    i48 i49 i50 i51 i52 i53 i54 i55 i56 i57 i58 i59 i60 i61 i62 i63
+    s0_buf s0_bar s1_buf s1_bar s2_buf s2_bar s3_buf s3_bar s4_buf s4_bar
+    s5_buf s5_bar
+    out MUX64_1_VDDL10

.ends MUX64_1_buf_VDDL10

* () MUX64_1_VDDL08
.subckt MUX64_1_VDDL08 i0 i1 i2 i3 i4 i5 i6 i7 i8 i9 i10 i11 i12 i13 i14 i15
+               i16 i17 i18 i19 i20 i21 i22 i23 i24 i25 i26 i27 i28 i29 i30 i31
+               i32 i33 i34 i35 i36 i37 i38 i39 i40 i41 i42 i43 i44 i45 i46 i47
+               i48 i49 i50 i51 i52 i53 i54 i55 i56 i57 i58 i59 i60 i61 i62 i63
+               s0 s0_b s1 s1_b s2 s2_b s3 s3_b s4 s4_b s5 s5_b out
xlev00 i0 i1 s0 s0_b lev00_out MUX2_1_VDDL08
xlev01 i2 i3 s0 s0_b lev01_out MUX2_1_VDDL08
xlev02 i4 i5 s0 s0_b lev02_out MUX2_1_VDDL08
xlev03 i6 i7 s0 s0_b lev03_out MUX2_1_VDDL08
xlev04 i8 i9 s0 s0_b lev04_out MUX2_1_VDDL08
xlev05 i10 i11 s0 s0_b lev05_out MUX2_1_VDDL08
xlev06 i12 i13 s0 s0_b lev06_out MUX2_1_VDDL08
xlev07 i14 i15 s0 s0_b lev07_out MUX2_1_VDDL08
xlev08 i16 i17 s0 s0_b lev08_out MUX2_1_VDDL08
xlev09 i18 i19 s0 s0_b lev09_out MUX2_1_VDDL08
xlev10 i20 i21 s0 s0_b lev10_out MUX2_1_VDDL08
xlev11 i22 i23 s0 s0_b lev11_out MUX2_1_VDDL08
xlev12 i24 i25 s0 s0_b lev12_out MUX2_1_VDDL08
xlev13 i26 i27 s0 s0_b lev13_out MUX2_1_VDDL08
xlev14 i28 i29 s0 s0_b lev14_out MUX2_1_VDDL08
xlev15 i30 i31 s0 s0_b lev15_out MUX2_1_VDDL08
xlev16 i32 i33 s0 s0_b lev16_out MUX2_1_VDDL08
xlev17 i34 i35 s0 s0_b lev17_out MUX2_1_VDDL08
xlev18 i36 i37 s0 s0_b lev18_out MUX2_1_VDDL08
xlev19 i38 i39 s0 s0_b lev19_out MUX2_1_VDDL08
xlev20 i40 i41 s0 s0_b lev20_out MUX2_1_VDDL08
xlev21 i42 i43 s0 s0_b lev21_out MUX2_1_VDDL08
xlev22 i44 i45 s0 s0_b lev22_out MUX2_1_VDDL08
xlev23 i46 i47 s0 s0_b lev23_out MUX2_1_VDDL08
xlev24 i48 i49 s0 s0_b lev24_out MUX2_1_VDDL08
xlev25 i50 i51 s0 s0_b lev25_out MUX2_1_VDDL08
xlev26 i52 i53 s0 s0_b lev26_out MUX2_1_VDDL08
xlev27 i54 i55 s0 s0_b lev27_out MUX2_1_VDDL08
xlev28 i56 i57 s0 s0_b lev28_out MUX2_1_VDDL08
xlev29 i58 i59 s0 s0_b lev29_out MUX2_1_VDDL08
xlev30 i60 i61 s0 s0_b lev30_out MUX2_1_VDDL08
xlev31 i62 i63 s0 s0_b lev31_out MUX2_1_VDDL08

xlev lev00_out lev01_out lev02_out lev03_out lev04_out lev05_out
+    lev06_out lev07_out lev08_out lev09_out lev10_out lev11_out
+    lev12_out lev13_out lev14_out lev15_out lev16_out lev17_out
+    lev18_out lev19_out lev20_out lev21_out lev22_out lev23_out
+    lev24_out lev25_out lev26_out lev27_out lev28_out lev29_out
+    lev30_out lev31_out
+    s1 s1_b s2 s2_b s3 s3_b s4 s4_b s5 s5_b out MUX32_1_VDDL08
.ends MUX64_1_VDDL08


* () MUX64_1_buf_VDDL08
.subckt MUX64_1_buf_VDDL08 vsp vbp vsn vbn 
+                   i0 i1 i2 i3 i4 i5 i6 i7 i8 i9 i10 i11 i12 i13 i14 i15
+              i16 i17 i18 i19 i20 i21 i22 i23 i24 i25 i26 i27 i28 i29 i30 i31
+              i32 i33 i34 i35 i36 i37 i38 i39 i40 i41 i42 i43 i44 i45 i46 i47
+              i48 i49 i50 i51 i52 i53 i54 i55 i56 i57 i58 i59 i60 i61 i62 i63
+                   s0 s1 s2 s3 s4 s5 out
xg01 vsp vbp vsn vbn s0 s0_intb INV_VDDL08
xg02 vsp vbp vsn vbn s0_intb s0_buf INV2x_VDDL08
xg03 vsp vbp vsn vbn s0 s0_bar INV2x_VDDL08
xg11 vsp vbp vsn vbn s1 s1_intb INV_VDDL08
xg12 vsp vbp vsn vbn s1_intb s1_buf INV2x_VDDL08
xg13 vsp vbp vsn vbn s1 s1_bar INV2x_VDDL08
xg21 vsp vbp vsn vbn s2 s2_intb INV_VDDL08
xg22 vsp vbp vsn vbn s2_intb s2_buf INV2x_VDDL08
xg23 vsp vbp vsn vbn s2 s2_bar INV2x_VDDL08
xg31 vsp vbp vsn vbn s3 s3_intb INV_VDDL08
xg32 vsp vbp vsn vbn s3_intb s3_buf INV2x_VDDL08
xg33 vsp vbp vsn vbn s3 s3_bar INV2x_VDDL08
xg41 vsp vbp vsn vbn s4 s4_intb INV_VDDL08
xg42 vsp vbp vsn vbn s4_intb s4_buf INV2x_VDDL08
xg43 vsp vbp vsn vbn s4 s4_bar INV2x_VDDL08
xg51 vsp vbp vsn vbn s5 s5_intb INV_VDDL08
xg52 vsp vbp vsn vbn s5_intb s5_buf INV2x_VDDL08
xg53 vsp vbp vsn vbn s5 s5_bar INV2x_VDDL08

xlev i0 i1 i2 i3 i4 i5 i6 i7 i8 i9 i10 i11 i12 i13 i14 i15
+    i16 i17 i18 i19 i20 i21 i22 i23 i24 i25 i26 i27 i28 i29 i30 i31
+    i32 i33 i34 i35 i36 i37 i38 i39 i40 i41 i42 i43 i44 i45 i46 i47
+    i48 i49 i50 i51 i52 i53 i54 i55 i56 i57 i58 i59 i60 i61 i62 i63
+    s0_buf s0_bar s1_buf s1_bar s2_buf s2_bar s3_buf s3_bar s4_buf s4_bar
+    s5_buf s5_bar
+    out MUX64_1_VDDL08

.ends MUX64_1_buf_VDDL08



* (13) MUX128_1_VDDL10
.subckt MUX128_1_VDDL10 i0 i1 i2 i3 i4 i5 i6 i7 i8 i9 i10 i11 i12 i13 i14 i15
+               i16 i17 i18 i19 i20 i21 i22 i23 i24 i25 i26 i27 i28 i29 i30 i31
+               i32 i33 i34 i35 i36 i37 i38 i39 i40 i41 i42 i43 i44 i45 i46 i47
+               i48 i49 i50 i51 i52 i53 i54 i55 i56 i57 i58 i59 i60 i61 i62 i63
+               i64 i65 i66 i67 i68 i69 i70 i71 i72 i73 i74 i75 i76 i77 i78 i79
+               i80 i81 i82 i83 i84 i85 i86 i87 i88 i89 i90 i91 i92 i93 i94 i95
+               i96 i97 i98 i99 i100 i101 i102 i103 i104 i105 i106 i107 i108
+               i109 i110 i111 i112 i113 i114 i115 i116 i117 i118 i119 i120
+               i121 i122 i123 i124 i125 i126 i127
+               s0 s0_b s1 s1_b s2 s2_b s3 s3_b s4 s4_b s5 s5_b s6 s6_b out
xlev00 i0 i1 s0 s0_b lev00_out MUX2_1_VDDL10
xlev01 i2 i3 s0 s0_b lev01_out MUX2_1_VDDL10
xlev02 i4 i5 s0 s0_b lev02_out MUX2_1_VDDL10
xlev03 i6 i7 s0 s0_b lev03_out MUX2_1_VDDL10
xlev04 i8 i9 s0 s0_b lev04_out MUX2_1_VDDL10
xlev05 i10 i11 s0 s0_b lev05_out MUX2_1_VDDL10
xlev06 i12 i13 s0 s0_b lev06_out MUX2_1_VDDL10
xlev07 i14 i15 s0 s0_b lev07_out MUX2_1_VDDL10
xlev08 i16 i17 s0 s0_b lev08_out MUX2_1_VDDL10
xlev09 i18 i19 s0 s0_b lev09_out MUX2_1_VDDL10
xlev10 i20 i21 s0 s0_b lev10_out MUX2_1_VDDL10
xlev11 i22 i23 s0 s0_b lev11_out MUX2_1_VDDL10
xlev12 i24 i25 s0 s0_b lev12_out MUX2_1_VDDL10
xlev13 i26 i27 s0 s0_b lev13_out MUX2_1_VDDL10
xlev14 i28 i29 s0 s0_b lev14_out MUX2_1_VDDL10
xlev15 i30 i31 s0 s0_b lev15_out MUX2_1_VDDL10
xlev16 i32 i33 s0 s0_b lev16_out MUX2_1_VDDL10
xlev17 i34 i35 s0 s0_b lev17_out MUX2_1_VDDL10
xlev18 i36 i37 s0 s0_b lev18_out MUX2_1_VDDL10
xlev19 i38 i39 s0 s0_b lev19_out MUX2_1_VDDL10
xlev20 i40 i41 s0 s0_b lev20_out MUX2_1_VDDL10
xlev21 i42 i43 s0 s0_b lev21_out MUX2_1_VDDL10
xlev22 i44 i45 s0 s0_b lev22_out MUX2_1_VDDL10
xlev23 i46 i47 s0 s0_b lev23_out MUX2_1_VDDL10
xlev24 i48 i49 s0 s0_b lev24_out MUX2_1_VDDL10
xlev25 i50 i51 s0 s0_b lev25_out MUX2_1_VDDL10
xlev26 i52 i53 s0 s0_b lev26_out MUX2_1_VDDL10
xlev27 i54 i55 s0 s0_b lev27_out MUX2_1_VDDL10
xlev28 i56 i57 s0 s0_b lev28_out MUX2_1_VDDL10
xlev29 i58 i59 s0 s0_b lev29_out MUX2_1_VDDL10
xlev30 i60 i61 s0 s0_b lev30_out MUX2_1_VDDL10
xlev31 i62 i63 s0 s0_b lev31_out MUX2_1_VDDL10
xlev32 i64 i65 s0 s0_b lev32_out MUX2_1_VDDL10
xlev33 i66 i67 s0 s0_b lev33_out MUX2_1_VDDL10
xlev34 i68 i69 s0 s0_b lev34_out MUX2_1_VDDL10
xlev35 i70 i71 s0 s0_b lev35_out MUX2_1_VDDL10
xlev36 i72 i73 s0 s0_b lev36_out MUX2_1_VDDL10
xlev37 i74 i75 s0 s0_b lev37_out MUX2_1_VDDL10
xlev38 i76 i77 s0 s0_b lev38_out MUX2_1_VDDL10
xlev39 i78 i79 s0 s0_b lev39_out MUX2_1_VDDL10
xlev40 i80 i81 s0 s0_b lev40_out MUX2_1_VDDL10
xlev41 i82 i83 s0 s0_b lev41_out MUX2_1_VDDL10
xlev42 i84 i85 s0 s0_b lev42_out MUX2_1_VDDL10
xlev43 i86 i87 s0 s0_b lev43_out MUX2_1_VDDL10
xlev44 i88 i89 s0 s0_b lev44_out MUX2_1_VDDL10
xlev45 i90 i91 s0 s0_b lev45_out MUX2_1_VDDL10
xlev46 i92 i93 s0 s0_b lev46_out MUX2_1_VDDL10
xlev47 i94 i95 s0 s0_b lev47_out MUX2_1_VDDL10
xlev48 i96 i97 s0 s0_b lev48_out MUX2_1_VDDL10
xlev49 i98 i99 s0 s0_b lev49_out MUX2_1_VDDL10
xlev50 i100 i101 s0 s0_b lev50_out MUX2_1_VDDL10
xlev51 i102 i103 s0 s0_b lev51_out MUX2_1_VDDL10
xlev52 i104 i105 s0 s0_b lev52_out MUX2_1_VDDL10
xlev53 i106 i107 s0 s0_b lev53_out MUX2_1_VDDL10
xlev54 i108 i109 s0 s0_b lev54_out MUX2_1_VDDL10
xlev55 i110 i111 s0 s0_b lev55_out MUX2_1_VDDL10
xlev56 i112 i113 s0 s0_b lev56_out MUX2_1_VDDL10
xlev57 i114 i115 s0 s0_b lev57_out MUX2_1_VDDL10
xlev58 i116 i117 s0 s0_b lev58_out MUX2_1_VDDL10
xlev59 i118 i119 s0 s0_b lev59_out MUX2_1_VDDL10
xlev60 i120 i121 s0 s0_b lev60_out MUX2_1_VDDL10
xlev61 i122 i123 s0 s0_b lev61_out MUX2_1_VDDL10
xlev62 i124 i125 s0 s0_b lev62_out MUX2_1_VDDL10
xlev63 i126 i127 s0 s0_b lev63_out MUX2_1_VDDL10

xlev lev00_out lev01_out lev02_out lev03_out lev04_out lev05_out
+    lev06_out lev07_out lev08_out lev09_out lev10_out lev11_out
+    lev12_out lev13_out lev14_out lev15_out lev16_out lev17_out
+    lev18_out lev19_out lev20_out lev21_out lev22_out lev23_out
+    lev24_out lev25_out lev26_out lev27_out lev28_out lev29_out
+    lev30_out lev31_out lev32_out lev33_out lev34_out lev35_out
+    lev36_out lev37_out lev38_out lev39_out lev40_out lev41_out
+    lev42_out lev43_out lev44_out lev45_out lev46_out lev47_out
+    lev48_out lev49_out lev50_out lev51_out lev52_out lev53_out
+    lev54_out lev55_out lev56_out lev57_out lev58_out lev59_out
+    lev60_out lev61_out lev62_out lev63_out
+    s1 s1_b s2 s2_b s3 s3_b s4 s4_b s5 s5_b s6 s6_b out MUX64_1_VDDL10
.ends MUX128_1_VDDL10


* (14) MUX128_1_buf_VDDL10
.subckt MUX128_1_buf_VDDL10 vsp vbp vsn vbn 
+                   i0 i1 i2 i3 i4 i5 i6 i7 i8 i9 i10 i11 i12 i13 i14 i15
+              i16 i17 i18 i19 i20 i21 i22 i23 i24 i25 i26 i27 i28 i29 i30 i31
+              i32 i33 i34 i35 i36 i37 i38 i39 i40 i41 i42 i43 i44 i45 i46 i47
+              i48 i49 i50 i51 i52 i53 i54 i55 i56 i57 i58 i59 i60 i61 i62 i63
+               i64 i65 i66 i67 i68 i69 i70 i71 i72 i73 i74 i75 i76 i77 i78 i79
+               i80 i81 i82 i83 i84 i85 i86 i87 i88 i89 i90 i91 i92 i93 i94 i95
+               i96 i97 i98 i99 i100 i101 i102 i103 i104 i105 i106 i107 i108
+               i109 i110 i111 i112 i113 i114 i115 i116 i117 i118 i119 i120
+               i121 i122 i123 i124 i125 i126 i127
+                   s0 s1 s2 s3 s4 s5 s6 out

xg01 vsp vbp vsn vbn s0 s0_intb INV_VDDL10
xg02 vsp vbp vsn vbn s0_intb s0_buf INV2x_VDDL10
xg03 vsp vbp vsn vbn s0 s0_bar INV2x_VDDL10
xg11 vsp vbp vsn vbn s1 s1_intb INV_VDDL10
xg12 vsp vbp vsn vbn s1_intb s1_buf INV2x_VDDL10
xg13 vsp vbp vsn vbn s1 s1_bar INV2x_VDDL10
xg21 vsp vbp vsn vbn s2 s2_intb INV_VDDL10
xg22 vsp vbp vsn vbn s2_intb s2_buf INV2x_VDDL10
xg23 vsp vbp vsn vbn s2 s2_bar INV2x_VDDL10
xg31 vsp vbp vsn vbn s3 s3_intb INV_VDDL10
xg32 vsp vbp vsn vbn s3_intb s3_buf INV2x_VDDL10
xg33 vsp vbp vsn vbn s3 s3_bar INV2x_VDDL10
xg41 vsp vbp vsn vbn s4 s4_intb INV_VDDL10
xg42 vsp vbp vsn vbn s4_intb s4_buf INV2x_VDDL10
xg43 vsp vbp vsn vbn s4 s4_bar INV2x_VDDL10
xg51 vsp vbp vsn vbn s5 s5_intb INV_VDDL10
xg52 vsp vbp vsn vbn s5_intb s5_buf INV2x_VDDL10
xg53 vsp vbp vsn vbn s5 s5_bar INV2x_VDDL10
xg61 vsp vbp vsn vbn s6 s6_intb INV_VDDL10
xg62 vsp vbp vsn vbn s6_intb s6_buf INV2x_VDDL10
xg63 vsp vbp vsn vbn s6 s6_bar INV2x_VDDL10

xlev i0 i1 i2 i3 i4 i5 i6 i7 i8 i9 i10 i11 i12 i13 i14 i15
+    i16 i17 i18 i19 i20 i21 i22 i23 i24 i25 i26 i27 i28 i29 i30 i31
+    i32 i33 i34 i35 i36 i37 i38 i39 i40 i41 i42 i43 i44 i45 i46 i47
+    i48 i49 i50 i51 i52 i53 i54 i55 i56 i57 i58 i59 i60 i61 i62 i63
+    i64 i65 i66 i67 i68 i69 i70 i71 i72 i73 i74 i75 i76 i77 i78 i79
+    i80 i81 i82 i83 i84 i85 i86 i87 i88 i89 i90 i91 i92 i93 i94 i95
+    i96 i97 i98 i99 i100 i101 i102 i103 i104 i105 i106 i107 i108
+    i109 i110 i111 i112 i113 i114 i115 i116 i117 i118 i119 i120
+    i121 i122 i123 i124 i125 i126 i127
+    s0_buf s0_bar s1_buf s1_bar s2_buf s2_bar s3_buf s3_bar s4_buf s4_bar
+    s5_buf s5_bar s6_buf s6_bar
+    out MUX128_1_VDDL10

.ends MUX128_1_buf_VDDL10
