*pass transistors with different size
*scalable lamda design rule

* Fei LI
* 07/04/02

* parameters
* =================
* lmda: design rule parameters (set in the file parameters.sp)
* v_supply: supply votage (set in the file parameters.sp)

* ports of the subckt and their functions
* =======================================
* in: data in
* out: data out
* ctrl: control line
* bulk: substrate of the transistor

.subckt NMOS_PASS5x in out ctrl bulk

*For 0.10um technology, l= 2*lmda = 0.10um
**eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out ctrl in bulk NMOS l='2*lmda' w='17.5*lmda' ad='122.5*lmda*lmda'
+ as='122.5*lmda*lmda' pd='105*lmda' ps='105*lmda'

.ends NMOS_PASS5x

* ---------------------------------------------------

.subckt NMOS_PASS in out ctrl bulk

*For 0.10um technology, l= 2*lmda = 0.10um
**eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out ctrl in bulk NMOS l='2*lmda' w='3.5*lmda' ad='24.5*lmda*lmda'
+ as='24.5*lmda*lmda' pd='21*lmda' ps='21*lmda'

.ends NMOS_PASS

* ---------------------------------------------------


* parameters
* =================
* lmda: design rule parameters (set in the file parameters.sp)
* v_supply: supply votage (set in the file parameters.sp)

* ports of the subckt and their functions
* =======================================
* in: data in
* out: data out
* ctrl: control line
* bulk: substrate of the transistor

.subckt NMOS_PASS10x in out ctrl bulk

*For 0.10um technology, l= 2*lmda = 0.10um
**eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out ctrl in bulk NMOS l='2*lmda' w='35*lmda' ad='245*lmda*lmda'
+ as='245*lmda*lmda' pd='210*lmda' ps='210*lmda'

.ends NMOS_PASS10x




* parameters
* =================
* lmda: design rule parameters (set in the file parameters.sp)
* v_supply: supply votage (set in the file parameters.sp)

* ports of the subckt and their functions
* =======================================
* in: data in
* out: data out
* ctrl: control line
* bulk: substrate of the transistor

.subckt PMOS_PASS5x in out ctrl bulk

*For 0.10um technology, l= 2*lmda = 0.10um
**eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out ctrl in bulk PMOS l='2*lmda' w='43.75*lmda' ad='765.625*lmda*lmda'
+ as='765.625*lmda*lmda' pd='262.5*lmda' ps='262.5*lmda'

.ends PMOS_PASS5x

.subckt PMOS_PASS in out ctrl bulk

*For 0.10um technology, l= 2*lmda = 0.10um
**eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out ctrl in bulk PMOS l='2*lmda' w='8.75*lmda' ad='153.125*lmda*lmda'
+ as='153.125*lmda*lmda' pd='52.5*lmda' ps='52.5*lmda'

.ends PMOS_PASS


* parameters
* =================
* lmda: design rule parameters (set in the file parameters.sp)
* v_supply: supply votage (set in the file parameters.sp)

* ports of the subckt and their functions
* =======================================
* in: data in
* out: data out
* ctrl: control line
* bulk: substrate of the transistor

.subckt PMOS_PASS10x in out ctrl bulk

*For 0.10um technology, l= 2*lmda = 0.10um
**eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out ctrl in bulk PMOS l='2*lmda' w='87.5*lmda' ad='1531.25*lmda*lmda'
+ as='1531.25*lmda*lmda' pd='525*lmda' ps='525*lmda'

.ends PMOS_PASS10x

.subckt PMOS_PASS7x in out ctrl bulk

*For 0.10um technology, l= 2*lmda = 0.10um
**eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out ctrl in bulk PMOS l='2*lmda' w='61.25*lmda' ad='1071.875*lmda*lmda'
+ as='1071.875*lmda*lmda' pd='367.5*lmda' ps='367.5*lmda'

.ends PMOS_PASS7x

.subckt PMOS_PASS12x in out ctrl bulk

*For 0.10um technology, l= 2*lmda = 0.10um
**eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out ctrl in bulk PMOS l='2*lmda' w='105*lmda' ad='1837.5*lmda*lmda'
+ as='1837.5*lmda*lmda' pd='630*lmda' ps='630*lmda'

.ends PMOS_PASS12x


.subckt PMOS_PASS15x in out ctrl bulk

*For 0.10um technology, l= 2*lmda = 0.10um
**eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out ctrl in bulk PMOS l='2*lmda' w='131.25*lmda' ad='2296.875*lmda*lmda'
+ as='2296.875*lmda*lmda' pd='787.5*lmda' ps='787.5*lmda'

.ends PMOS_PASS15x

.subckt PMOS_PASS17x in out ctrl bulk

*For 0.10um technology, l= 2*lmda = 0.10um
**eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out ctrl in bulk PMOS l='2*lmda' w='148.75*lmda' ad='2603.125*lmda*lmda'
+ as='2603.125*lmda*lmda' pd='892.5*lmda' ps='892.5*lmda'

.ends PMOS_PASS17x

.subckt PMOS_PASS20x in out ctrl bulk

*For 0.10um technology, l= 2*lmda = 0.10um
**eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out ctrl in bulk PMOS l='2*lmda' w='175*lmda' ad='3062.5*lmda*lmda'
+ as='3062.5*lmda*lmda' pd='1050*lmda' ps='1050*lmda'

.ends PMOS_PASS20x

.subckt PMOS_PASS22x in out ctrl bulk

*For 0.10um technology, l= 2*lmda = 0.10um
**eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out ctrl in bulk PMOS l='2*lmda' w='192.5*lmda' ad='3368.75*lmda*lmda'
+ as='3368.75*lmda*lmda' pd='1155*lmda' ps='1155*lmda'

.ends PMOS_PASS22x

.subckt PMOS_PASS25x in out ctrl bulk

*For 0.10um technology, l= 2*lmda = 0.10um
**eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out ctrl in bulk PMOS l='2*lmda' w='218.75*lmda' ad='3828.125*lmda*lmda'
+ as='3828.125*lmda*lmda' pd='1312.5*lmda' ps='1312.5*lmda'

.ends PMOS_PASS25x

.subckt PMOS_PASS27x in out ctrl bulk

*For 0.10um technology, l= 2*lmda = 0.10um
**eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out ctrl in bulk PMOS l='2*lmda' w='236.25*lmda' ad='4134.375*lmda*lmda'
+ as='4134.375*lmda*lmda' pd='1417.5*lmda' ps='1417.5*lmda'

.ends PMOS_PASS27x

.subckt PMOS_PASS30x in out ctrl bulk

*For 0.10um technology, l= 2*lmda = 0.10um
**eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out ctrl in bulk PMOS l='2*lmda' w='262.5*lmda' ad='4593.75*lmda*lmda'
+ as='4593.75*lmda*lmda' pd='1575*lmda' ps='1575*lmda'

.ends PMOS_PASS30x


.subckt NMOS_PASS7x in out ctrl bulk

*For 0.10um technology, l= 2*lmda = 0.10um
**eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out ctrl in bulk NMOS l='2*lmda' w='24.5*lmda' ad='171.5*lmda*lmda'
+ as='171.5*lmda*lmda' pd='147*lmda' ps='147*lmda'

.ends NMOS_PASS7x

.subckt NMOS_PASS12x in out ctrl bulk

*For 0.10um technology, l= 2*lmda = 0.10um
**eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out ctrl in bulk NMOS l='2*lmda' w='42*lmda' ad='294*lmda*lmda'
+ as='294*lmda*lmda' pd='252*lmda' ps='252*lmda'

.ends NMOS_PASS12x

.subckt NMOS_PASS15x in out ctrl bulk

*For 0.10um technology, l= 2*lmda = 0.10um
**eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out ctrl in bulk NMOS l='2*lmda' w='52.5*lmda' ad='367.5*lmda*lmda'
+ as='367.5*lmda*lmda' pd='315*lmda' ps='315*lmda'

.ends NMOS_PASS15x

.subckt NMOS_PASS17x in out ctrl bulk

*For 0.10um technology, l= 2*lmda = 0.10um
**eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out ctrl in bulk NMOS l='2*lmda' w='59.5*lmda' ad='416.5*lmda*lmda'
+ as='416.5*lmda*lmda' pd='357*lmda' ps='357*lmda'

.ends NMOS_PASS17x

.subckt NMOS_PASS20x in out ctrl bulk

*For 0.10um technology, l= 2*lmda = 0.10um
**eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out ctrl in bulk NMOS l='2*lmda' w='70*lmda' ad='490*lmda*lmda'
+ as='490*lmda*lmda' pd='420*lmda' ps='420*lmda'

.ends NMOS_PASS20x

.subckt NMOS_PASS22x in out ctrl bulk

*For 0.10um technology, l= 2*lmda = 0.10um
**eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out ctrl in bulk NMOS l='2*lmda' w='77*lmda' ad='539*lmda*lmda'
+ as='539*lmda*lmda' pd='462*lmda' ps='462*lmda'

.ends NMOS_PASS22x

.subckt NMOS_PASS25x in out ctrl bulk

*For 0.10um technology, l= 2*lmda = 0.10um
**eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out ctrl in bulk NMOS l='2*lmda' w='87.5*lmda' ad='612.5*lmda*lmda'
+ as='612.5*lmda*lmda' pd='525*lmda' ps='525*lmda'

.ends NMOS_PASS25x

.subckt NMOS_PASS27x in out ctrl bulk

*For 0.10um technology, l= 2*lmda = 0.10um
**eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out ctrl in bulk NMOS l='2*lmda' w='94.5*lmda' ad='661.5*lmda*lmda'
+ as='661.5*lmda*lmda' pd='567*lmda' ps='567*lmda'

.ends NMOS_PASS27x

.subckt NMOS_PASS30x in out ctrl bulk

*For 0.10um technology, l= 2*lmda = 0.10um
**eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out ctrl in bulk NMOS l='2*lmda' w='105*lmda' ad='735*lmda*lmda'
+ as='735*lmda*lmda' pd='630*lmda' ps='630*lmda'

.ends NMOS_PASS30x



.subckt NMOS_PASS35x in out ctrl bulk

*For 0.10um technology, l= 2*lmda = 0.10um
**eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out ctrl in bulk NMOS l='2*lmda' w='122.5*lmda' ad='857.5*lmda*lmda'
+ as='857.5*lmda*lmda' pd='735*lmda' ps='735*lmda'

.ends NMOS_PASS35x


.subckt NMOS_PASS40x in out ctrl bulk

*For 0.10um technology, l= 2*lmda = 0.10um
**eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out ctrl in bulk NMOS l='2*lmda' w='140*lmda' ad='980*lmda*lmda'
+ as='980*lmda*lmda' pd='840*lmda' ps='840*lmda'

.ends NMOS_PASS40x


* --------------------------------------
* For low vdd = 1.0v (Vt scaled with Vdd)

.subckt NMOS_PASS_VDDL10 in out ctrl bulk

*For 0.10um technology, l= 2*lmda = 0.10um
**eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out ctrl in bulk NMOS_VDDL10 l='2*lmda' w='3.5*lmda' ad='24.5*lmda*lmda'
+ as='24.5*lmda*lmda' pd='21*lmda' ps='21*lmda'

.ends NMOS_PASS_VDDL10



* For low vdd = 0.9v (Vt scaled with Vdd)

.subckt NMOS_PASS_VDDL09 in out ctrl bulk

*For 0.10um technology, l= 2*lmda = 0.10um
**eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out ctrl in bulk NMOS_VDDL09 l='2*lmda' w='3.5*lmda' ad='24.5*lmda*lmda'
+ as='24.5*lmda*lmda' pd='21*lmda' ps='21*lmda'

.ends NMOS_PASS_VDDL09



* For low vdd = 0.8v (Vt scaled with Vdd)

.subckt NMOS_PASS_VDDL08 in out ctrl bulk

*For 0.10um technology, l= 2*lmda = 0.10um
**eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out ctrl in bulk NMOS_VDDL08 l='2*lmda' w='3.5*lmda' ad='24.5*lmda*lmda'
+ as='24.5*lmda*lmda' pd='21*lmda' ps='21*lmda'

.ends NMOS_PASS_VDDL08



* For low vdd = 0.7v (Vt scaled with Vdd)

.subckt NMOS_PASS_VDDL07 in out ctrl bulk

*For 0.10um technology, l= 2*lmda = 0.10um
**eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out ctrl in bulk NMOS_VDDL07 l='2*lmda' w='3.5*lmda' ad='24.5*lmda*lmda'
+ as='24.5*lmda*lmda' pd='21*lmda' ps='21*lmda'

.ends NMOS_PASS_VDDL07

* ---------------------

.subckt NMOS_PASS5x_VDDL10 in out ctrl bulk

*For 0.10um technology, l= 2*lmda = 0.10um
**eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out ctrl in bulk NMOS_VDDL10 l='2*lmda' w='17.5*lmda' ad='122.5*lmda*lmda'
+ as='122.5*lmda*lmda' pd='105*lmda' ps='105*lmda'

.ends NMOS_PASS5x_VDDL10

.subckt NMOS_PASS5x_VDDL09 in out ctrl bulk

*For 0.10um technology, l= 2*lmda = 0.10um
**eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out ctrl in bulk NMOS_VDDL09 l='2*lmda' w='17.5*lmda' ad='122.5*lmda*lmda'
+ as='122.5*lmda*lmda' pd='105*lmda' ps='105*lmda'

.ends NMOS_PASS5x_VDDL09


.subckt NMOS_PASS5x_VDDL08 in out ctrl bulk

*For 0.10um technology, l= 2*lmda = 0.10um
**eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out ctrl in bulk NMOS_VDDL08 l='2*lmda' w='17.5*lmda' ad='122.5*lmda*lmda'
+ as='122.5*lmda*lmda' pd='105*lmda' ps='105*lmda'

.ends NMOS_PASS5x_VDDL08

* ---------------------

.subckt NMOS_PASS10x_VDDL10 in out ctrl bulk

*For 0.10um technology, l= 2*lmda = 0.10um
**eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out ctrl in bulk NMOS_VDDL10 l='2*lmda' w='35*lmda' ad='245*lmda*lmda'
+ as='245*lmda*lmda' pd='210*lmda' ps='210*lmda'

.ends NMOS_PASS10x_VDDL10

.subckt NMOS_PASS10x_VDDL09 in out ctrl bulk

*For 0.10um technology, l= 2*lmda = 0.10um
**eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out ctrl in bulk NMOS_VDDL09 l='2*lmda' w='35*lmda' ad='245*lmda*lmda'
+ as='245*lmda*lmda' pd='210*lmda' ps='210*lmda'

.ends NMOS_PASS10x_VDDL09

.subckt NMOS_PASS10x_VDDL08 in out ctrl bulk

*For 0.10um technology, l= 2*lmda = 0.10um
**eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out ctrl in bulk NMOS_VDDL08 l='2*lmda' w='35*lmda' ad='245*lmda*lmda'
+ as='245*lmda*lmda' pd='210*lmda' ps='210*lmda'

.ends NMOS_PASS10x_VDDL08

* ---------------------

.subckt NMOS_PASS7x_VDDL10 in out ctrl bulk

*For 0.10um technology, l= 2*lmda = 0.10um
**eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out ctrl in bulk NMOS_VDDL10 l='2*lmda' w='24.5*lmda' ad='171.5*lmda*lmda'
+ as='171.5*lmda*lmda' pd='147*lmda' ps='147*lmda'

.ends NMOS_PASS7x_VDDL10

.subckt NMOS_PASS7x_VDDL09 in out ctrl bulk

*For 0.10um technology, l= 2*lmda = 0.10um
**eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out ctrl in bulk NMOS_VDDL09 l='2*lmda' w='24.5*lmda' ad='171.5*lmda*lmda'
+ as='171.5*lmda*lmda' pd='147*lmda' ps='147*lmda'

.ends NMOS_PASS7x_VDDL09

.subckt NMOS_PASS7x_VDDL08 in out ctrl bulk

*For 0.10um technology, l= 2*lmda = 0.10um
**eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out ctrl in bulk NMOS_VDDL08 l='2*lmda' w='24.5*lmda' ad='171.5*lmda*lmda'
+ as='171.5*lmda*lmda' pd='147*lmda' ps='147*lmda'

.ends NMOS_PASS7x_VDDL08

* ---------------------
.subckt NMOS_PASS12x_VDDL10 in out ctrl bulk

*For 0.10um technology, l= 2*lmda = 0.10um
**eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out ctrl in bulk NMOS_VDDL10 l='2*lmda' w='42*lmda' ad='294*lmda*lmda'
+ as='294*lmda*lmda' pd='252*lmda' ps='252*lmda'

.ends NMOS_PASS12x_VDDL10

.subckt NMOS_PASS12x_VDDL09 in out ctrl bulk

*For 0.10um technology, l= 2*lmda = 0.10um
**eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out ctrl in bulk NMOS_VDDL09 l='2*lmda' w='42*lmda' ad='294*lmda*lmda'
+ as='294*lmda*lmda' pd='252*lmda' ps='252*lmda'

.ends NMOS_PASS12x_VDDL09

.subckt NMOS_PASS12x_VDDL08 in out ctrl bulk

*For 0.10um technology, l= 2*lmda = 0.10um
**eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out ctrl in bulk NMOS_VDDL08 l='2*lmda' w='42*lmda' ad='294*lmda*lmda'
+ as='294*lmda*lmda' pd='252*lmda' ps='252*lmda'

.ends NMOS_PASS12x_VDDL08

* ---------------------
.subckt NMOS_PASS15x_VDDL10 in out ctrl bulk

*For 0.10um technology, l= 2*lmda = 0.10um
**eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out ctrl in bulk NMOS_VDDL10 l='2*lmda' w='52.5*lmda' ad='367.5*lmda*lmda'
+ as='367.5*lmda*lmda' pd='315*lmda' ps='315*lmda'

.ends NMOS_PASS15x_VDDL10

.subckt NMOS_PASS15x_VDDL09 in out ctrl bulk

*For 0.10um technology, l= 2*lmda = 0.10um
**eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out ctrl in bulk NMOS_VDDL09 l='2*lmda' w='52.5*lmda' ad='367.5*lmda*lmda'
+ as='367.5*lmda*lmda' pd='315*lmda' ps='315*lmda'

.ends NMOS_PASS15x_VDDL09

.subckt NMOS_PASS15x_VDDL08 in out ctrl bulk

*For 0.10um technology, l= 2*lmda = 0.10um
**eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out ctrl in bulk NMOS_VDDL08 l='2*lmda' w='52.5*lmda' ad='367.5*lmda*lmda'
+ as='367.5*lmda*lmda' pd='315*lmda' ps='315*lmda'

.ends NMOS_PASS15x_VDDL08

* ---------------------
.subckt NMOS_PASS17x_VDDL10 in out ctrl bulk

*For 0.10um technology, l= 2*lmda = 0.10um
**eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out ctrl in bulk NMOS_VDDL10 l='2*lmda' w='59.5*lmda' ad='416.5*lmda*lmda'
+ as='416.5*lmda*lmda' pd='357*lmda' ps='357*lmda'

.ends NMOS_PASS17x_VDDL10

.subckt NMOS_PASS17x_VDDL09 in out ctrl bulk

*For 0.10um technology, l= 2*lmda = 0.10um
**eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out ctrl in bulk NMOS_VDDL09 l='2*lmda' w='59.5*lmda' ad='416.5*lmda*lmda'
+ as='416.5*lmda*lmda' pd='357*lmda' ps='357*lmda'

.ends NMOS_PASS17x_VDDL09

.subckt NMOS_PASS17x_VDDL08 in out ctrl bulk

*For 0.10um technology, l= 2*lmda = 0.10um
**eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out ctrl in bulk NMOS_VDDL08 l='2*lmda' w='59.5*lmda' ad='416.5*lmda*lmda'
+ as='416.5*lmda*lmda' pd='357*lmda' ps='357*lmda'

.ends NMOS_PASS17x_VDDL08

* ---------------------
.subckt NMOS_PASS20x_VDDL10 in out ctrl bulk

*For 0.10um technology, l= 2*lmda = 0.10um
**eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out ctrl in bulk NMOS_VDDL10 l='2*lmda' w='70*lmda' ad='490*lmda*lmda'
+ as='490*lmda*lmda' pd='420*lmda' ps='420*lmda'

.ends NMOS_PASS20x_VDDL10

.subckt NMOS_PASS20x_VDDL09 in out ctrl bulk

*For 0.10um technology, l= 2*lmda = 0.10um
**eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out ctrl in bulk NMOS_VDDL09 l='2*lmda' w='70*lmda' ad='490*lmda*lmda'
+ as='490*lmda*lmda' pd='420*lmda' ps='420*lmda'

.ends NMOS_PASS20x_VDDL09

.subckt NMOS_PASS20x_VDDL08 in out ctrl bulk

*For 0.10um technology, l= 2*lmda = 0.10um
**eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out ctrl in bulk NMOS_VDDL08 l='2*lmda' w='70*lmda' ad='490*lmda*lmda'
+ as='490*lmda*lmda' pd='420*lmda' ps='420*lmda'

.ends NMOS_PASS20x_VDDL08

* ---------------------
.subckt NMOS_PASS22x_VDDL10 in out ctrl bulk

*For 0.10um technology, l= 2*lmda = 0.10um
**eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out ctrl in bulk NMOS_VDDL10 l='2*lmda' w='77*lmda' ad='539*lmda*lmda'
+ as='539*lmda*lmda' pd='462*lmda' ps='462*lmda'

.ends NMOS_PASS22x_VDDL10

.subckt NMOS_PASS22x_VDDL09 in out ctrl bulk

*For 0.10um technology, l= 2*lmda = 0.10um
**eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out ctrl in bulk NMOS_VDDL09 l='2*lmda' w='77*lmda' ad='539*lmda*lmda'
+ as='539*lmda*lmda' pd='462*lmda' ps='462*lmda'

.ends NMOS_PASS22x_VDDL09

.subckt NMOS_PASS22x_VDDL08 in out ctrl bulk

*For 0.10um technology, l= 2*lmda = 0.10um
**eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out ctrl in bulk NMOS_VDDL08 l='2*lmda' w='77*lmda' ad='539*lmda*lmda'
+ as='539*lmda*lmda' pd='462*lmda' ps='462*lmda'

.ends NMOS_PASS22x_VDDL08

* ---------------------
.subckt NMOS_PASS25x_VDDL10 in out ctrl bulk

*For 0.10um technology, l= 2*lmda = 0.10um
**eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out ctrl in bulk NMOS_VDDL10 l='2*lmda' w='87.5*lmda' ad='612.5*lmda*lmda'
+ as='612.5*lmda*lmda' pd='525*lmda' ps='525*lmda'

.ends NMOS_PASS25x_VDDL10

.subckt NMOS_PASS25x_VDDL09 in out ctrl bulk

*For 0.10um technology, l= 2*lmda = 0.10um
**eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out ctrl in bulk NMOS_VDDL09 l='2*lmda' w='87.5*lmda' ad='612.5*lmda*lmda'
+ as='612.5*lmda*lmda' pd='525*lmda' ps='525*lmda'

.ends NMOS_PASS25x_VDDL09

.subckt NMOS_PASS25x_VDDL08 in out ctrl bulk

*For 0.10um technology, l= 2*lmda = 0.10um
**eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out ctrl in bulk NMOS_VDDL08 l='2*lmda' w='87.5*lmda' ad='612.5*lmda*lmda'
+ as='612.5*lmda*lmda' pd='525*lmda' ps='525*lmda'

.ends NMOS_PASS25x_VDDL08

* ---------------------
.subckt NMOS_PASS27x_VDDL10 in out ctrl bulk

*For 0.10um technology, l= 2*lmda = 0.10um
**eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out ctrl in bulk NMOS_VDDL10 l='2*lmda' w='94.5*lmda' ad='661.5*lmda*lmda'
+ as='661.5*lmda*lmda' pd='567*lmda' ps='567*lmda'

.ends NMOS_PASS27x_VDDL10

.subckt NMOS_PASS27x_VDDL09 in out ctrl bulk

*For 0.10um technology, l= 2*lmda = 0.10um
**eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out ctrl in bulk NMOS_VDDL09 l='2*lmda' w='94.5*lmda' ad='661.5*lmda*lmda'
+ as='661.5*lmda*lmda' pd='567*lmda' ps='567*lmda'

.ends NMOS_PASS27x_VDDL09

.subckt NMOS_PASS27x_VDDL08 in out ctrl bulk

*For 0.10um technology, l= 2*lmda = 0.10um
**eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out ctrl in bulk NMOS_VDDL08 l='2*lmda' w='94.5*lmda' ad='661.5*lmda*lmda'
+ as='661.5*lmda*lmda' pd='567*lmda' ps='567*lmda'

.ends NMOS_PASS27x_VDDL08

* ---------------------
.subckt NMOS_PASS30x_VDDL10 in out ctrl bulk

*For 0.10um technology, l= 2*lmda = 0.10um
**eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out ctrl in bulk NMOS_VDDL10 l='2*lmda' w='105*lmda' ad='735*lmda*lmda'
+ as='735*lmda*lmda' pd='630*lmda' ps='630*lmda'

.ends NMOS_PASS30x_VDDL10

.subckt NMOS_PASS30x_VDDL09 in out ctrl bulk

*For 0.10um technology, l= 2*lmda = 0.10um
**eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out ctrl in bulk NMOS_VDDL09 l='2*lmda' w='105*lmda' ad='735*lmda*lmda'
+ as='735*lmda*lmda' pd='630*lmda' ps='630*lmda'

.ends NMOS_PASS30x_VDDL09

.subckt NMOS_PASS30x_VDDL08 in out ctrl bulk

*For 0.10um technology, l= 2*lmda = 0.10um
**eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out ctrl in bulk NMOS_VDDL08 l='2*lmda' w='105*lmda' ad='735*lmda*lmda'
+ as='735*lmda*lmda' pd='630*lmda' ps='630*lmda'

.ends NMOS_PASS30x_VDDL08

* ---------------------
.subckt NMOS_PASS35x_VDDL10 in out ctrl bulk

*For 0.10um technology, l= 2*lmda = 0.10um
**eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out ctrl in bulk NMOS_VDDL10 l='2*lmda' w='122.5*lmda' ad='857.5*lmda*lmda'
+ as='857.5*lmda*lmda' pd='735*lmda' ps='735*lmda'

.ends NMOS_PASS35x_VDDL10

.subckt NMOS_PASS35x_VDDL09 in out ctrl bulk

*For 0.10um technology, l= 2*lmda = 0.10um
**eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out ctrl in bulk NMOS_VDDL09 l='2*lmda' w='122.5*lmda' ad='857.5*lmda*lmda'
+ as='857.5*lmda*lmda' pd='735*lmda' ps='735*lmda'

.ends NMOS_PASS35x_VDDL09

.subckt NMOS_PASS35x_VDDL08 in out ctrl bulk

*For 0.10um technology, l= 2*lmda = 0.10um
**eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out ctrl in bulk NMOS_VDDL08 l='2*lmda' w='122.5*lmda' ad='857.5*lmda*lmda'
+ as='857.5*lmda*lmda' pd='735*lmda' ps='735*lmda'

.ends NMOS_PASS35x_VDDL08

* ---------------------
.subckt NMOS_PASS40x_VDDL10 in out ctrl bulk

*For 0.10um technology, l= 2*lmda = 0.10um
**eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out ctrl in bulk NMOS_VDDL10 l='2*lmda' w='140*lmda' ad='980*lmda*lmda'
+ as='980*lmda*lmda' pd='840*lmda' ps='840*lmda'

.ends NMOS_PASS40x_VDDL10

.subckt NMOS_PASS40x_VDDL09 in out ctrl bulk

*For 0.10um technology, l= 2*lmda = 0.10um
**eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out ctrl in bulk NMOS_VDDL09 l='2*lmda' w='140*lmda' ad='980*lmda*lmda'
+ as='980*lmda*lmda' pd='840*lmda' ps='840*lmda'

.ends NMOS_PASS40x_VDDL09

.subckt NMOS_PASS40x_VDDL08 in out ctrl bulk

*For 0.10um technology, l= 2*lmda = 0.10um
**eg. .param lmda=0.05u (this parameter will be set in file parameters.sp)

m1 out ctrl in bulk NMOS_VDDL08 l='2*lmda' w='140*lmda' ad='980*lmda*lmda'
+ as='980*lmda*lmda' pd='840*lmda' ps='840*lmda'

.ends NMOS_PASS40x_VDDL08

